// DlgLayers.cpp : implementation file
//

#include "stdafx.h"
#include "ElecDraw.h"
#include "DlgLayers.h"
#include "Primitive.h"
#include "DlgMacroBar.h"
#include "ConfigDialog.h"
#include "GridDialog.h"
#include "ViewToolbar.h"
#include "ElecDrawDoc.h"
#include "ElecDrawView.h"
#include "LayerComboBox.h"
#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDlgLayers dialog


CDlgLayers::CDlgLayers(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgLayers::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgLayers)
	//}}AFX_DATA_INIT
}

void CDlgLayers::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgLayers)
	//}}AFX_DATA_MAP

	// Uso direttamente gli array di CMainFrame
	CString *pNames = ((CMainFrame *)AfxGetMainWnd())->m_layerNames;
	COLORREF *pColors = ((CMainFrame *)AfxGetMainWnd())->m_layerColors;
	BOOL *pScreen = ((CMainFrame *)AfxGetMainWnd())->m_bLayerShow;
	BOOL *pPrinter = ((CMainFrame *)AfxGetMainWnd())->m_bLayerPrint;
	int a;

	for( a=0; a<16; a++)
	{
		DDX_Text( pDX, IDC_LAYER_TEXT0+a, pNames[a]);
		DDX_Check( pDX, IDC_LAYER_SCR0+a, pScreen[a]);
		DDX_Check( pDX, IDC_LAYER_PRN0+a, pPrinter[a]);

		// Creo brushes
		if( pDX->m_bSaveAndValidate)
		{
			LOGBRUSH lb;
			m_brushes[a].GetLogBrush( &lb);
			pColors[a] = lb.lbColor;
		}
		else
			m_brushes[a].CreateSolidBrush( pColors[a]);
	}
}

BEGIN_MESSAGE_MAP(CDlgLayers, CDialog)
	//{{AFX_MSG_MAP(CDlgLayers)
	ON_WM_PAINT()
	ON_WM_LBUTTONUP()
	ON_BN_CLICKED(IDC_SCREEN_ALL, OnScreenAll)
	ON_BN_CLICKED(IDC_SCREEN_NONE, OnScreenNone)
	ON_BN_CLICKED(IDC_PRINT_ALL, OnPrintAll)
	ON_BN_CLICKED(IDC_PRINT_NONE, OnPrintNone)
	ON_BN_CLICKED(IDC_LAYER_SAVE_VIS, OnLayerSaveVis)
	ON_BN_CLICKED(IDC_LAYER_SAVE_NAMES, OnLayerSaveNames)
	ON_BN_CLICKED(IDC_LAYER_SAVE_COLORS, OnLayerSaveColors)
	ON_BN_CLICKED(IDC_LAYER_RESTORE_VIS, OnLayerRestoreVis)
	ON_BN_CLICKED(IDC_LAYER_RESTORE_NAMES, OnLayerRestoreNames)
	ON_BN_CLICKED(IDC_LAYER_RESTORE_COLORS, OnLayerRestoreColors)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlgLayers message handlers

BOOL CDlgLayers::OnInitDialog() 
{
	CDialog::OnInitDialog();

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CDlgLayers::OnPaint() 
{
	CPaintDC dc(this); // device context for painting

	CRect rc;
	CBrush *old;
	int a;
	for( a=0; a<16; a++)
	{
		GetDlgItem( IDC_LAYER_COLOR0+a)->GetWindowRect( &rc);
		ScreenToClient( &rc);
		old = dc.SelectObject( &m_brushes[a]);
		dc.Rectangle( &rc);
		dc.SelectObject( old);
	}
}

void CDlgLayers::OnLButtonUp(UINT nFlags, CPoint point) 
{
	/* Intercetto i click sui rettangolini dei colori */
	int a;
	CRect rc;
	for( a=0; a<16; a++)
	{
		GetDlgItem( IDC_LAYER_COLOR0+a)->GetWindowRect( &rc);
		ScreenToClient( &rc);
		if( rc.PtInRect( point))
			break;
	}

	if( a<16)
	{
		LOGBRUSH lb;
		m_brushes[a].GetLogBrush( &lb);
		
		CColorDialog dlg( lb.lbColor, CC_RGBINIT, this);
		if( dlg.DoModal() == IDOK)
		{
			m_brushes[a].DeleteObject();
			m_brushes[a].CreateSolidBrush( dlg.GetColor());
			InvalidateRect( rc, FALSE);
			UpdateWindow();
		}
	}

	CDialog::OnLButtonUp(nFlags, point);
}

void CDlgLayers::OnScreenAll() 
{
	int a;
	for( a=0; a<16; a++)
		((CButton*)GetDlgItem( IDC_LAYER_SCR0+a))->SetCheck( 1);
}

void CDlgLayers::OnScreenNone() 
{
	int a;
	for( a=0; a<16; a++)
		((CButton*)GetDlgItem( IDC_LAYER_SCR0+a))->SetCheck( 0);
}

void CDlgLayers::OnPrintAll() 
{
	int a;
	for( a=0; a<16; a++)
		((CButton*)GetDlgItem( IDC_LAYER_PRN0+a))->SetCheck( 1);
}

void CDlgLayers::OnPrintNone() 
{
	int a;
	for( a=0; a<16; a++)
		((CButton*)GetDlgItem( IDC_LAYER_PRN0+a))->SetCheck( 0);

}

void CDlgLayers::OnLayerSaveVis() 
{
	((CMainFrame *)AfxGetMainWnd())->LayerSaveShow();
	((CMainFrame *)AfxGetMainWnd())->LayerSavePrint();
}

void CDlgLayers::OnLayerSaveNames() 
{
	((CMainFrame *)AfxGetMainWnd())->LayerSaveNames();
}

void CDlgLayers::OnLayerSaveColors() 
{
	((CMainFrame *)AfxGetMainWnd())->LayerSaveColors();
}

void CDlgLayers::OnLayerRestoreVis() 
{
	((CMainFrame *)AfxGetMainWnd())->LayerDefaultShow();
	((CMainFrame *)AfxGetMainWnd())->LayerDefaultPrint();

	BOOL *pScreen = ((CMainFrame *)AfxGetMainWnd())->m_bLayerShow;
	BOOL *pPrinter = ((CMainFrame *)AfxGetMainWnd())->m_bLayerPrint;

	int a;
	for( a=0; a<16; a++)
	{
		((CButton*)GetDlgItem( IDC_LAYER_SCR0+a))->SetCheck( pScreen[a] ? 1 : 0);
		((CButton*)GetDlgItem( IDC_LAYER_PRN0+a))->SetCheck( pPrinter[a] ? 1 : 0);
	}
}

void CDlgLayers::OnLayerRestoreNames() 
{
	((CMainFrame *)AfxGetMainWnd())->LayerDefaultNames();

	CString *pNames = ((CMainFrame *)AfxGetMainWnd())->m_layerNames;	

	int a;
	for( a=0; a<16; a++)
		GetDlgItem( IDC_LAYER_TEXT0+a)->SetWindowText( pNames[a]);
}

void CDlgLayers::OnLayerRestoreColors() 
{
	((CMainFrame *)AfxGetMainWnd())->LayerDefaultColors();

	COLORREF *pColors = ((CMainFrame *)AfxGetMainWnd())->m_layerColors;

	int a;
	for( a=0; a<16; a++)
	{
		m_brushes[a].DeleteObject();
		m_brushes[a].CreateSolidBrush( pColors[a]);

		CRect rc;
		GetDlgItem( IDC_LAYER_COLOR0+a)->GetWindowRect( &rc);
		ScreenToClient( &rc);
		InvalidateRect( rc, FALSE);
	}

	UpdateWindow();
}
