// DlgLibBuf.cpp : implementation file
//

#include "stdafx.h"
#include "ElecDraw.h"
#include "DlgLibBuf.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDlgLibBuf dialog


CDlgLibBuf::CDlgLibBuf(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgLibBuf::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgLibBuf)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CDlgLibBuf::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgLibBuf)
	DDX_Control(pDX, IDC_LIBSLIST, m_libs);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDlgLibBuf, CDialog)
	//{{AFX_MSG_MAP(CDlgLibBuf)
	ON_BN_CLICKED(IDC_LIB_BUF, OnLibBuf)
	ON_BN_CLICKED(IDC_LIB_UNBUF, OnLibUnbuf)
	ON_NOTIFY(NM_CLICK, IDC_LIBSLIST, OnClickLibslist)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlgLibBuf message handlers

BOOL CDlgLibBuf::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	/*
		Inserisco tutte le librerie contenute nella directory libs nella listview,
		mettendo un check diverso su quelle bufferizzate
	*/
	m_imagelist.Create( IDB_BUFIMAGES, 18, 2, RGB(255,255,255));
	m_libs.SetImageList( &m_imagelist, LVSIL_STATE);

	WIN32_FIND_DATA wfd;
	HANDLE h;
	CString str, tmp;
	int nItem = 0;
	str.Format( "%s\\%s\\*.%s", LPCSTR(_BaseDir), LIBS_DIR, LIBS_EXT);
	if(	(h = ::FindFirstFile( LPCSTR(str), &wfd)) != INVALID_HANDLE_VALUE)
	{
		do
		{
			char onlyname[1024];
			_splitpath( wfd.cFileName, NULL, NULL, onlyname, NULL);
			m_libs.InsertItem( nItem, onlyname);
			if( _FileNamesCache.Lookup( onlyname, tmp))
				m_libs.SetCheck( nItem, TRUE);
			else
				m_libs.SetCheck( nItem, FALSE);

			nItem++;
		} while( FindNextFile( h, &wfd));

		FindClose( h);
	}

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CDlgLibBuf::OnClickLibslist(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// In base allo stato degli elementi selezionati, attiva
	// uno o l'altro pulsante
	BOOL bBuf=FALSE, bUnbuf=FALSE;
	POSITION pos = m_libs.GetFirstSelectedItemPosition();
	while( pos)
	{
		int nItem = m_libs.GetNextSelectedItem( pos);
		if( m_libs.GetCheck( nItem))
			bUnbuf = TRUE;
		else
			bBuf = TRUE;
	}

	GetDlgItem( IDC_LIB_BUF)->EnableWindow( bBuf);
	GetDlgItem( IDC_LIB_UNBUF)->EnableWindow( bUnbuf);
	*pResult = 0;
}

void CDlgLibBuf::OnLibBuf() 
{
	// Seleziona per la bufferizzazione tutti gli elementi selezionati
	POSITION pos = m_libs.GetFirstSelectedItemPosition();
	while( pos)
	{
		int nItem = m_libs.GetNextSelectedItem( pos);
		m_libs.SetCheck( nItem,TRUE);
	}

	GetDlgItem( IDC_LIB_BUF)->EnableWindow( FALSE);
	GetDlgItem( IDC_LIB_UNBUF)->EnableWindow( TRUE);
}

void CDlgLibBuf::OnLibUnbuf() 
{
	// Deseleziona per la bufferizzazione tutti gli elementi selezionati
	POSITION pos = m_libs.GetFirstSelectedItemPosition();
	while( pos)
	{
		int nItem = m_libs.GetNextSelectedItem( pos);
		m_libs.SetCheck( nItem, FALSE);
	}

	GetDlgItem( IDC_LIB_BUF)->EnableWindow( TRUE);
	GetDlgItem( IDC_LIB_UNBUF)->EnableWindow( FALSE);
}

void CDlgLibBuf::OnOK() 
{
	_FileNamesCache.RemoveAll();
	int a, n=m_libs.GetItemCount();
	for( a=0; a<n; a++)
	{
		if( m_libs.GetCheck( a))
		{
			CString str;
			str = m_libs.GetItemText( a, 0);
			_FileNamesCache.SetAt( str, str);
		}
	}
	
	CDialog::OnOK();
}
