// DlgLibNum.cpp : implementation file
//

#include "stdafx.h"
#include "ElecDraw.h"
#include "Primitive.h"
#include "DlgLibNum.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDlgLibNum dialog


CDlgLibNum::CDlgLibNum(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgLibNum::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgLibNum)
	m_nIncrement = 1;
	m_Prefix = _T("M");
	m_nStart = 0;
	m_bAddZeroes = FALSE;
	//}}AFX_DATA_INIT

	m_libArray = NULL;
}


void CDlgLibNum::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgLibNum)
	DDX_Text(pDX, IDC_EDIT_INCR, m_nIncrement);
	DDV_MinMaxInt(pDX, m_nIncrement, 1, 100000000);
	DDX_Text(pDX, IDC_EDIT_PREFIX, m_Prefix);
	DDV_MaxChars(pDX, m_Prefix, 8);
	DDX_Text(pDX, IDC_EDIT_STARTNUM, m_nStart);
	DDV_MinMaxInt(pDX, m_nStart, 0, 100000000);
	DDX_Check(pDX, IDC_CHECK_ADDZEROS, m_bAddZeroes);
	//}}AFX_DATA_MAP
}

void CDlgLibNum::SetLibArray( STRARRAY* ar)
{
	m_libArray = ar;
}


BEGIN_MESSAGE_MAP(CDlgLibNum, CDialog)
	//{{AFX_MSG_MAP(CDlgLibNum)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlgLibNum message handlers

void CDlgLibNum::OnOK() 
{
	UpdateData( TRUE);

	// Verifica che tutte le stringhe che verranno generate sottostiano
	// alle regole dei nomi corti (max 8 caratteri, alfanumerici o sottotratto)
	CString spanned = m_Prefix.SpanExcluding( "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789_");
	if( spanned != "")
	{
		MessageBox( "Il prefisso adottato e' invalido. I nomi brevi possono "
			"essere composti soltanto da caretteri alfanumerici o dal sottotratto.");
		return;
	}

	CString tb;
	int maxlen = 0;
	int a, b, c, n=m_libArray->GetSize();
	for( a=m_nStart, b=0; b<n; a+=m_nIncrement, b++)
	{
		tb.Format("%s%d", LPCSTR(m_Prefix), a);
		if( (c = tb.GetLength()) > 8)
		{
			MessageBox( "Con le impostazioni attuali, uno o piu' titoli brevi "
				"occuperebbero piu' degli 8 caratteri consentiti. Accorciare "
				"il prefisso e/o ridurre il numero di partenza e/o l'incremento.");
			return;
		}

		if( c > maxlen)
			maxlen = c;
	}

	// OK, va tutto bene! Procediamo.
	CString zeroes;
	CString number;
	CString* pnt;
	BOOL bError = FALSE;
	for( a=m_nStart, b=0; b<n; a+=m_nIncrement, b++)
	{
		// Stringa originale
		pnt = m_libArray->GetAt(b);

		// Stringa del numero
		number.Format("%d", a);

		// Stringa degli zeri
		zeroes = "";
		if( m_bAddZeroes)
		{
			int nZeroes = maxlen - m_Prefix.GetLength() - number.GetLength();
			for( int k=0; k<nZeroes; k++) zeroes += '0';
		}

		// Sostituisce la parte iniziale dell'header
		try
		{
			int i1 = pnt->Find('[');
			CString s1 = pnt->Mid(i1+1);

			if( s1[0] == ' ')
			{
				int i2 = 1;
				while( s1[i2] == ' ') i2++;
				s1 = s1.Mid(i2);
			}

			int i2 = s1.Find(' ');
			CString s2 = s1.Mid(i2);

			*pnt = CString("[") + m_Prefix + zeroes + number + s2;
		}
		catch( CMemoryException* e)
		{
			bError = TRUE;
			continue;
			e->Delete();
		}
	}

	if( bError)
	{
		MessageBox( "Sono stati incontrati uno o piu' errori in fase di "
			"numerazione. Alcuni componenti potrebbero non essere stati "
			"numerati correttamente.");
	}

	CDialog::OnOK();
}
