// DlgMacroBar.cpp : implementation file
//

#include "stdafx.h"
//#include "DlgSplash.h"
#include "ElecDraw.h"
#include "Primitive.h"
#include "DlgMacroBar.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDlgMacroBar dialog


CDlgMacroBar::CDlgMacroBar() : CDialogBar()
{
	m_hRoot = NULL;
	m_ImageList.Create( IDB_TREEIMAGES, 18, 0, RGB(255,255,255));
}

BEGIN_MESSAGE_MAP(CDlgMacroBar, CDialogBar)
	//{{AFX_MSG_MAP(CDlgMacroBar)
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

void CDlgMacroBar::WipeOut()
{
	CTreeCtrl* tc = (CTreeCtrl*)GetDlgItem(IDC_TREE_MACRO);

	// Distrugge tutte le etichette, non prima di aver rimosso le stringhe
	// corrispondenti
	if( m_hRoot != NULL)
	{
		CString* pstr;
		HTREEITEM hFirstLevel = tc->GetChildItem( m_hRoot);
		while( hFirstLevel != NULL)
		{
			// Prima guarda se c'e' una stringa associata al primo livello (es. macro)
			if( (pstr = (CString*)(tc->GetItemData( hFirstLevel))) != NULL)
				delete pstr;

			// Poi guarda il sottolivello
			HTREEITEM hSecondLevel = tc->GetChildItem( hFirstLevel);
			while( hSecondLevel != NULL)
			{
				if( (pstr = (CString*)(tc->GetItemData( hSecondLevel))) != NULL)
					delete pstr;
				
				// Se e` una libreria con sottodir c'e` un altro livello!
				HTREEITEM hThirdLevel = tc->GetChildItem( hSecondLevel);
				while( hThirdLevel != NULL)
				{
					if( (pstr = (CString*)(tc->GetItemData( hThirdLevel))) != NULL)
						delete pstr;

					hThirdLevel = tc->GetNextItem( hThirdLevel, TVGN_NEXT);
				}

				hSecondLevel = tc->GetNextItem( hSecondLevel, TVGN_NEXT);
			}

			hFirstLevel = tc->GetNextItem( hFirstLevel, TVGN_NEXT);
		}

	}
	tc->DeleteAllItems();

	m_hRoot = NULL;
}

void CDlgMacroBar::ReloadAll()
{
	CWaitCursor pippo;

	WipeOut();

	// Carica la image list
	CTreeCtrl* tc = (CTreeCtrl*)GetDlgItem(IDC_TREE_MACRO);
	tc->SetImageList( &m_ImageList, TVSIL_NORMAL);	

	// Ricrea la root (non importa settare l'item data)
	m_hRoot = tc->InsertItem( "Macro disponibili", 0, 0);

	CString buf;

	// Libreria standard (builtin)
	STRARRAY stdlib;
	LPSTR lpRes;
	HANDLE hResInfo, hRes;
	hResInfo = ::FindResource( NULL, MAKEINTRESOURCE(IDR_STDLIB), "STDLIBS");
	if( hResInfo != NULL)
	{
    	hRes = ::LoadResource( NULL, (HRSRC)hResInfo);
    	if (hRes != NULL)
		{
    		lpRes = (LPSTR)(::LockResource( hRes));
    		if( lpRes != NULL)
    		{
				buf = CString( lpRes);
        		::UnlockResource( hRes);
    		}
    		::FreeResource( hRes);
		}
	}
	// Aggiunge libreria
	AddToTree( buf, CString(""));


	// Librerie non standard
	WIN32_FIND_DATA wfd;
	HANDLE h;
	CString str;
	str.Format( "%s\\%s\\*.%s", LPCSTR(_BaseDir), LIBS_DIR, LIBS_EXT);
	if(	(h = ::FindFirstFile( LPCSTR(str), &wfd)) != INVALID_HANDLE_VALUE)
	{
		do
		{
			CString libname;
			libname.Format( "%s\\%s\\%s", LPCSTR(_BaseDir), LIBS_DIR, wfd.cFileName);

			// Scanna il buffer
			if( !CPrimitive::ScanFile( libname, NULL, NULL, NULL, NULL, NULL, &buf))
				continue;

			// Nome breve della libreria (nome file senza estensione ne' path)
			CString LibBrief( wfd.cFileName);
			int idx = LibBrief.ReverseFind('.');
			if( idx != -1)
				LibBrief = LibBrief.Left(idx);

			// Aggiunge libreria
			AddToTree( buf, LibBrief);

		} while( FindNextFile( h, &wfd));

		FindClose( h);
	}

	// Scan delle macro "sfuse".
	str.Format( "%s\\%s\\*.%s", LPCSTR(_BaseDir), MACROS_DIR, MACROS_EXT);
	if(	(h = ::FindFirstFile( LPCSTR(str), &wfd)) != INVALID_HANDLE_VALUE)
	{
		do
		{
			CString macroname;
			macroname.Format( "%s\\%s\\%s", LPCSTR(_BaseDir), MACROS_DIR, wfd.cFileName);

			// Prima di caricare le informazioni si assicura che sia una macro
			DOC_TYPE t;
			if( !CPrimitive::ScanFile( macroname, NULL, NULL, NULL, NULL, &t) ||
				t != DOC_MACRO)
					continue;

			// Poi OK, carica e scanna
			CString macrotitle;
			if( !CPrimitive::ScanFile( macroname, NULL, NULL, &macrotitle, NULL, NULL))
				continue;

			// Nome breve della macro (nome file senza estensione ne' path)
			CString MacroBrief( wfd.cFileName);
			int idx = MacroBrief.ReverseFind('.');
			if( idx != -1)
				MacroBrief = MacroBrief.Left(idx);

			// Crea l'elemento di primo livello
			HTREEITEM h1 = tc->InsertItem( macrotitle, 3, 3, m_hRoot);
			if( h1 != NULL)
			{
				CString* loadname = new CString( MacroBrief);
				tc->SetItemData( h1, (DWORD)loadname);
			}

		} while( FindNextFile( h, &wfd));

		FindClose( h);
	}

	tc->Expand( m_hRoot, TVE_EXPAND);
}

BOOL CDlgMacroBar::AddToTree( CString& buf, CString& ShortLib)
{
	CTreeCtrl* tc = (CTreeCtrl*)GetDlgItem(IDC_TREE_MACRO);	
	CString Title;
	STRARRAY lc;
	SUBDIRARRAY sda;
	if( !CPrimitive::ScanHeadedBuffer( buf, NULL, &lc, &Title, NULL, NULL, &sda))
		return FALSE;

	// Crea l'elemento di primo livello (la libreria vera e propria)
	HTREEITEM h1 = tc->InsertItem( Title, 1, 2, m_hRoot);
	tc->SetItemData( h1, 0);

	// Poi crea tutte le subdirs, aggiungendo via via i componenti
	int b, m=sda.GetSize();
	for( b=0; b<m; b++)
	{
		// I componenti dentro a 'hidden' semplicemente li ignoriamo
		if( sda[b].name == "hidden")
			continue;

		// Se la stringa e` vuota, niente subdir
		HTREEITEM hsub = NULL;
		if( sda[b].name != "")
		{
			hsub = tc->InsertItem( sda[b].name, 1, 2, h1);
			tc->SetItemData( hsub, 0);
		}

		// Guarda quanti componenti sono in questa dir!
		int a;
		int n = (b==m-1) ? lc.GetSize() : sda[b+1].index;
		for( a=sda[b].index; a<n; a++)
		{
			CMacro temp;
			CString MacroBrief, MacroLong;
			if( CMacro::ScanLibraryMacro( *(lc[a]), &temp, &MacroBrief, &MacroLong, NULL))
			{
				HTREEITEM h2 = tc->InsertItem( MacroLong, 3, 3, (hsub==NULL) ? h1 : hsub);
				CString* loadname = new CString;
				if( ShortLib == "")
					*loadname = CString("~") + MacroBrief;
				else
					*loadname = ShortLib + CString(".") + MacroBrief;

				// Se non ci sono gia', bufferizza le macro
				CPrimitive* q;
				if( !_MacroCache.Lookup( *loadname, (CObject*&)q))
				{
					CPrimitive *r = temp.Clone();
					r->SetAttrib( "Text", *loadname);
					_MacroCache.SetAt( *loadname, r);
					
					// Lib standard? Mettiamo anche il nome senza tilda
					if( ShortLib == "")
					{
						r = temp.Clone();
						r->SetAttrib( "Text", *loadname);
						_MacroCache.SetAt( MacroBrief, r);
					}
				}

				tc->SetItemData( h2, (DWORD)loadname);
			}
		}
		
		//tc->Expand( h1, TVE_EXPAND);
	}

	// Elimina la fame nel mondo
	int z, k=lc.GetSize();
	for( z=0; z<k; z++)
		delete (lc[z]);

	return TRUE;
}

CString* CDlgMacroBar::GetSelectedMacro()
{
	CTreeCtrl* tc = (CTreeCtrl*)GetDlgItem(IDC_TREE_MACRO);
	HTREEITEM h = tc->GetSelectedItem();

	if( h != NULL)
		return (CString*)(tc->GetItemData(h));

	return NULL;
}


void CDlgMacroBar::OnDestroy() 
{
	WipeOut();
	CDialogBar::OnDestroy();
}
