// ElecDraw.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
//#include "DlgSplash.h"
#include "ElecDraw.h"
#include "Primitive.h"
#include "DlgMacroBar.h"
#include "GridDialog.h"
#include "ConfigDialog.h"
//#include "SpectrumAnalyzer.h"
#include "AboutDlg.h"
#include "ViewToolbar.h"
#include "ElecDrawDoc.h"
#include "ElecDrawLibDoc.h"
#include "ElecDrawView.h"
#include "LayerComboBox.h"
#include "MainFrm.h"
#include "Splash.h"
#include "MyMDIChildWnd.h"
//#include <htmlhelp.h>


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CElecDrawApp

BEGIN_MESSAGE_MAP(CElecDrawApp, CWinApp)
	//{{AFX_MSG_MAP(CElecDrawApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
	ON_COMMAND(ID_FILE_NEW, OnFileNew)
	//}}AFX_MSG_MAP
	// Standard file based document commands
	ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)
	// Standard print setup command
	ON_COMMAND(ID_FILE_PRINT_SETUP, CWinApp::OnFilePrintSetup)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CElecDrawApp construction

CElecDrawApp::CElecDrawApp()
{
}

/////////////////////////////////////////////////////////////////////////////
// Globalozzi. A parte _theApp sono tutte variabili che si poteva evitare di
// definire global; le ho messe giusto per far brontolare i puristi del C++,
// che non hanno nient'altro da fare nella vita.

CElecDrawApp _theApp;
CString _BaseDir;
CMapStringToOb _MacroCache;
CMapStringToString _FileNamesCache;


/////////////////////////////////////////////////////////////////////////////
// CElecDrawApp initialization

BOOL CElecDrawApp::InitInstance()
{
	// Inizializza valori default primitive
	CPrimitive::InitLastSettings();

	// Parse command line for standard shell commands, DDE, file open
	CCommandLineInfo cmdInfo;
	ParseCommandLine(cmdInfo);

	// Splash screen
	CSplashWnd::EnableSplashScreen(cmdInfo.m_bShowSplash);


#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif

	SetRegistryKey( "Lutti Corporation");
	LoadStdProfileSettings(6);  // Load standard INI file options (including MRU)

	// Register document templates
	CMultiDocTemplate* pDocTemplate;
	pDocTemplate = new CMultiDocTemplate(
		IDR_CHILDFRAME,
		RUNTIME_CLASS(CElecDrawDoc),
		RUNTIME_CLASS(CMyMDIChildWnd),
		RUNTIME_CLASS(CElecDrawView));
	AddDocTemplate(pDocTemplate);
	pDocTemplate = new CMultiDocTemplate(
		IDR_CHILDFRAMEMACRO,
		RUNTIME_CLASS(CElecDrawDoc),
		RUNTIME_CLASS(CMyMDIChildWnd),
		RUNTIME_CLASS(CElecDrawView));
	AddDocTemplate(pDocTemplate);
	pDocTemplate = new CMultiDocTemplate(
		IDR_CHILDFRAMELIB,
		RUNTIME_CLASS(CElecDrawLibDoc),
		RUNTIME_CLASS(CMyMDIChildWnd),
		RUNTIME_CLASS(CElecDrawView));
	AddDocTemplate(pDocTemplate);

	CMainFrame *pMainFrame = new CMainFrame;
	if( !pMainFrame->LoadFrame( IDR_MAINFRAME))
		return FALSE;
	m_pMainWnd = pMainFrame;

	m_pMainWnd->DragAcceptFiles();
	EnableShellOpen();

	// Registra i file solo se specificato
	if( GetProfileInt( "Configurazione", "bRegisterFileTypes", TRUE))
		RegisterShellFileTypes( TRUE);

	// Non crea un nuovo file all'avvio
	if( cmdInfo.m_nShellCommand != CCommandLineInfo::FileNew)
		if (!ProcessShellCommand(cmdInfo))
			return FALSE;
  
	m_pMainWnd->ShowWindow( m_nCmdShow);
	m_pMainWnd->UpdateWindow();
	return TRUE;
}

// App command to run the dialog
void CElecDrawApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}

/////////////////////////////////////////////////////////////////////////////
// CElecDrawApp commands

void CElecDrawApp::OnFileNew() 
{
	CWinApp::OnFileNew();
}

int CElecDrawApp::ExitInstance() 
{
	// Libera la cache delle macro
	CPrimitive* prim;
	CString suck;
	POSITION p = _MacroCache.GetStartPosition();
	while( p != NULL)
	{
		_MacroCache.GetNextAssoc( p, suck, (CObject*&)prim);
		delete prim;
	}
	
	return CWinApp::ExitInstance();
}

BOOL CElecDrawApp::PreTranslateMessage(MSG* pMsg)
{
	// CG: The following line was added by the Splash Screen component.
	CSplashWnd::PreTranslateAppMessage(pMsg);

	return CWinApp::PreTranslateMessage(pMsg);
}

void CElecDrawApp::WinHelp(DWORD dwData, UINT nCmd) 
{
	// TODO: Add your specialized code here and/or call the base class
	
	// ::HtmlHelp( ::AfxGetMainWnd()->m_hWnd, _BaseDir + "\\FidoCAD.chm", nCmd, dwData);

	CWinApp::WinHelp(dwData, nCmd);
}
