// ElecDrawDoc.h : interface of the CElecDrawDoc class
//
/////////////////////////////////////////////////////////////////////////////

class CElecDrawDoc : public CDocument
{
protected: // create from serialization only
	CElecDrawDoc();
	DECLARE_DYNCREATE(CElecDrawDoc)

	int WarningMessage();
	BOOL StdName( CString& name);

	CArray<CString,CString>		m_undobuffer;
	int							m_bufsize;
	int							m_redopos;


public:
	UINT GetID();

	int UndoReset( int size=-1);
	int UndoStore();
	int Undo();
	int Redo();
	BOOL CanUndo();
	BOOL CanRedo();
	void UpdateBoundingRegions( CDC *pdc, PRIMARRAY& array);
	void GetRealSize( CRect& rc);

	PRIMARRAY					m_selArray;
	PRIMARRAY					m_compArray;
	CViewToolBar				m_TitleToolBar;


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CElecDrawDoc)
	public:
	virtual void Serialize(CArchive& ar);
	virtual void DeleteContents();
	virtual void ReportSaveLoadException(LPCTSTR lpszPathName, CException* e, BOOL bSaving, UINT nIDPDefault);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CElecDrawDoc();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif


// Generated message map functions
protected:
	//{{AFX_MSG(CElecDrawDoc)
	afx_msg void OnFileSave();
	afx_msg void OnFileSaveAs();
	afx_msg void OnEditUndo();
	afx_msg void OnUpdateEditUndo(CCmdUI* pCmdUI);
	afx_msg void OnEditRedo();
	afx_msg void OnUpdateEditRedo(CCmdUI* pCmdUI);
	afx_msg void OnFileSavebmp();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////
