// ElecDrawView.cpp : implementation of the CElecDrawView class
//

#include "stdafx.h"
//#include "DlgSplash.h"
#include "ElecDraw.h"
#include "Primitive.h"
#include "DlgMacroBar.h"
#include "GridDialog.h"
#include "ConfigDialog.h"
#include "ViewToolbar.h"
#include "ElecDrawDoc.h"
#include "ElecDrawView.h"
#include "LayerComboBox.h"
#include "MainFrm.h"
#include "LayerComboBox.h"
#include "GiveStringDialog.h"

#include <math.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CElecDrawView

IMPLEMENT_DYNCREATE(CElecDrawView, CView)

BEGIN_MESSAGE_MAP(CElecDrawView, CView)
	//{{AFX_MSG_MAP(CElecDrawView)
	ON_WM_LBUTTONDOWN()
	ON_WM_MOUSEMOVE()
	ON_WM_RBUTTONUP()
	ON_WM_LBUTTONUP()
	ON_COMMAND(ID_EDIT_PROPERTIES, OnEditProperties)
	ON_UPDATE_COMMAND_UI(ID_EDIT_PROPERTIES, OnUpdateEditProperties)
	ON_WM_SIZE()
	ON_WM_HSCROLL()
	ON_WM_VSCROLL()
	ON_UPDATE_COMMAND_UI(ID_EDIT_COPY, OnUpdateEditCopy)
	ON_COMMAND(ID_EDIT_CUT, OnEditCut)
	ON_COMMAND(ID_EDIT_PASTE, OnEditPaste)
	ON_UPDATE_COMMAND_UI(ID_EDIT_PASTE, OnUpdateEditPaste)
	ON_COMMAND(ID_EDIT_COPY, OnEditCopy)
	ON_UPDATE_COMMAND_UI(ID_EDIT_CUT, OnUpdateEditCut)
	ON_WM_KEYDOWN()
	ON_WM_SETCURSOR()
	ON_COMMAND(ID_EDIT_CLEAR, OnEditClear)
	ON_UPDATE_COMMAND_UI(ID_EDIT_CLEAR, OnUpdateEditClear)
	ON_COMMAND(ID_EDIT_SPLITMACRO, OnEditSplitmacro)
	ON_UPDATE_COMMAND_UI(ID_EDIT_SPLITMACRO, OnUpdateEditSplitmacro)
	ON_COMMAND(ID_EDIT_INVERT, OnEditInvert)
	ON_COMMAND(ID_VIEW_STRETCH, OnViewStretch)
	ON_COMMAND(ID_VIEW_GRID, OnViewGrid)
	ON_UPDATE_COMMAND_UI(ID_VIEW_STRETCH, OnUpdateViewStretch)
	ON_COMMAND(ID_EDIT_SELECT_ALL, OnEditSelectAll)
	ON_WM_LBUTTONDBLCLK()
	ON_WM_RBUTTONDOWN()
	ON_WM_TIMER()
	ON_COMMAND(ID_EDIT_CREAMACRO, OnEditCreamacro)
	ON_UPDATE_COMMAND_UI(ID_EDIT_CREAMACRO, OnUpdateEditCreamacro)
	ON_COMMAND(ID_VIEW_FIT, OnViewFit)
	ON_COMMAND(ID_EDIT_ROTATE, OnEditRotate)
	ON_UPDATE_COMMAND_UI(ID_EDIT_ROTATE, OnUpdateEditRotate)
	ON_COMMAND(ID_EDIT_SWAP, OnEditSwap)
	ON_UPDATE_COMMAND_UI(ID_EDIT_SWAP, OnUpdateEditSwap)
	ON_CBN_EDITCHANGE(IDC_COMBO_ZOOM,OnComboZoomEditChange)
	ON_CBN_SELCHANGE(IDC_COMBO_ZOOM,OnComboZoomSelChange)
	ON_COMMAND(ID_BUTTON_GOTOORIGIN, OnButtonGotoorigin)
	ON_COMMAND(ID_VIEW_REFRESH, OnViewRefresh)
	ON_WM_ERASEBKGND()
	ON_COMMAND(ID_SNAP, OnButtonSnap)
	ON_UPDATE_COMMAND_UI(ID_SNAP, OnUpdateButtonSnap)
	ON_COMMAND(ID_BUTTON_PCBMODE, OnButtonPcbmode)
	ON_UPDATE_COMMAND_UI(ID_BUTTON_PCBMODE, OnUpdateButtonPcbmode)
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CElecDrawView construction/destruction

CElecDrawView::CElecDrawView()
{
}

CElecDrawView::~CElecDrawView()
{
}

BOOL CElecDrawView::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CView::PreCreateWindow(cs))
		return FALSE;

	m_NormCursor = AfxGetApp()->LoadStandardCursor( IDC_ARROW);
	m_LensCursor = AfxGetApp()->LoadCursor( IDC_LENSCURSOR);
	m_CrossCursor = AfxGetApp()->LoadStandardCursor( IDC_CROSS);
	m_SizeCursor = AfxGetApp()->LoadCursor( IDC_SIZECURSOR);
	m_MoveCursor = AfxGetApp()->LoadCursor( IDC_MOVECURSOR);
	m_DragClosedCursor = AfxGetApp()->LoadCursor( IDC_DRAGCLOSE);
	m_DragOpenCursor = AfxGetApp()->LoadCursor( IDC_DRAGOPEN);
	
	cs.style |= WS_VSCROLL;
	cs.style |= WS_HSCROLL;
	return TRUE;
}


/////////////////////////////////////////////////////////////////////////////
// CElecDrawView drawing

void CElecDrawView::OnDraw(CDC* pDC)
{
	PRIMARRAY& CompArray = GetDocument()->m_compArray;
	PRIMARRAY& SelArray = GetDocument()->m_selArray;
	static CPen white_pen( PS_SOLID, 0, RGB(255,255,255));
	BOOL bRegion = ((CMainFrame *)AfxGetMainWnd())->m_bRegionDebug;
	BOOL bMirrorPCB = ((CMainFrame *)AfxGetMainWnd())->m_dlgConfig.m_bPrintMirror;

	// Trova le coordinate logiche del rettangolo visibile
	CRect rc;
	GetClientRect( &rc);
	pDC->DPtoLP( &rc);
	rc.InflateRect( 1, 1);

	// Se siamo in anteprima di stampa pcb, trova anche il rettangolo "reale"
	CRect rcReal(0,0,DEFAULT_AREAX, DEFAULT_AREAY);
	if( bMirrorPCB && m_PCBmode && pDC->IsPrinting())
		GetDocument()->GetRealSize( rcReal);

	// Disegna lo sfondo visibile
	CPen *oldpen = pDC->SelectObject( &white_pen);
	pDC->Rectangle( &rc);
	pDC->SelectObject( oldpen);

	// Disegna soltanto la porzione di griglia visibile
	if( m_GridDlg.m_bGridShow && !(pDC->IsPrinting()))
	{
		int x, y;
		int sy = ABS(rc.top)%m_GridDlg.m_ygrid;
		int sx = ABS(rc.left)%m_GridDlg.m_xgrid;
		if( rc.top < 0) sy *= -1;
		if( rc.left < 0) sx *= -1;
		for( y=rc.top-sy; y<rc.bottom && y<DEFAULT_AREAY; y+=m_GridDlg.m_ygrid)
			for( x=rc.left-sx; x<rc.right && x<DEFAULT_AREAX; x+=m_GridDlg.m_xgrid)
				pDC->SetPixel( x, y, RGB( 0, 0, 0));
	}

	/*
		Disegna soltanto le primitive visibili (dal layer piu` basso a quello piu` alto)
		La drawing priority vale solo all'interno di un layer, i componenti di
		un layer superiore hanno sempre la precedenza su quelli nel layer inferiore.
	*/
	int ll, lp, lc, n=CompArray.GetSize();
	CPrimitive *p;
	CRect rcp;

	for( ll=0; ll<16; ll++)
	{
		// Stampo solo i layer visibili...
		if( pDC->IsPrinting())
		{
			if( !(((CMainFrame*)AfxGetMainWnd())->m_bLayerPrint[ll]))
				continue;
		}
		else
		{
			if( !(((CMainFrame*)AfxGetMainWnd())->m_bLayerShow[ll]))
				continue;
		}

		// ...alla priorita` giusta
		for( lp=0; lp<=6; lp++)
		{
			for( lc=0; lc<n; lc++)
			{
				// Le macro passano sempre (basta che siamo nella loro priorita`) perche` potrebbero
				// contenere componenti su qualsiasi layer
				p = CompArray.GetAt( lc);
				if( ((p->GetProp() & PROP_ISMACRO) || p->GetLayer() == ll)
						&& p->GetDrawPriority() == lp)
				{
					/*
						Trova il colore con cui disegnare la primitiva
						(in stampa usiamo solo il nero)
					*/
					COLORREF clr = pDC->IsPrinting() ? RGB(0,0,0) : ((CMainFrame *)AfxGetMainWnd())->m_layerColors[p->GetLayer()];

					if( !pDC->IsPrinting())
					{
						if( p->GetRegion()->m_hObject != NULL)
							p->GetRegion()->GetRgnBox( &rcp);
						else
							rcp.CopyRect( rc);
					}

					if( pDC->IsPrinting() || RettangoloDentro( rcp, rc, TRUE))
					{
						if( bRegion && p->GetRegion()->m_hObject != NULL)
							pDC->PaintRgn( p->GetRegion());
						
						if( bMirrorPCB && m_PCBmode && pDC->IsPrinting())
						{
							CPrimitive *backup = p->Clone();
							backup->Swap( rcReal.left + rcReal.Width()/2);
							if( backup->GetProp() & PROP_ISMACRO)
								((CMacro*)backup)->Draw( pDC, FALSE, RGB(255,255,255), clr, RGB(255,0,0), 100, ll);
							else
								backup->Draw( pDC, FALSE, RGB(255,255,255), clr);
							delete backup;
						}
						else
						{
							if( p->GetProp() & PROP_ISMACRO)
								((CMacro*)p)->Draw( pDC, FALSE, RGB(255,255,255), clr, RGB(255,0,0), 100, ll);
							else
								p->Draw( pDC, FALSE, RGB(255,255,255), clr);
						}
					}	
				}
			}
		}
	}
	
	if( !(pDC->IsPrinting()))
		DrawDefPoints( pDC, CompArray);
}

BOOL CElecDrawView::OnEraseBkgnd(CDC* pDC) 
{
	// Gestione del background in OnDraw()
	return FALSE;

	//return CView::OnEraseBkgnd(pDC);
}

/////////////////////////////////////////////////////////////////////////////
// CElecDrawView printing

BOOL CElecDrawView::OnPreparePrinting(CPrintInfo* pInfo)
{
	PRIMARRAY& SelArray = GetDocument()->m_selArray;
	PRIMARRAY& CompArray = GetDocument()->m_compArray;
	DeselectAllObjects( CompArray, SelArray, FALSE);
	pInfo->SetMaxPage( 1);
	return DoPreparePrinting(pInfo);
}

void CElecDrawView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
}

void CElecDrawView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
}

/////////////////////////////////////////////////////////////////////////////
// CElecDrawView diagnostics

#ifdef _DEBUG
void CElecDrawView::AssertValid() const
{
	CView::AssertValid();
}

void CElecDrawView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CElecDrawDoc* CElecDrawView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CElecDrawDoc)));
	return (CElecDrawDoc*)m_pDocument;
}
#endif //_DEBUG


/////////////////////////////////////////////////////////////////////////////
// Gestione scrolling

void CElecDrawView::OnInitialUpdate() 
{
	m_ClickPoint = CPoint(-1,-1);
	m_bRectangleSel = FALSE;
	m_bChanging = FALSE;
	m_bMoving = FALSE;
	m_bMoveFirst = FALSE;
	m_bNew = FALSE;
	m_bDragging = FALSE;
	m_bJustKill = FALSE;
	m_bSecca = FALSE;
	m_bTimer = FALSE;
	m_bScrollRedraw = FALSE;
	m_nPointToChange = -1;
	m_PCBmode = FALSE;

	// Carica il menu contestuale
	m_ContextMenu.LoadMenu( IDR_PROPMENU);

	// Crea la toolbar del titolo
	GetDocument()->m_TitleToolBar.ArcordetDocument( GetDocument());
	if( !GetDocument()->m_TitleToolBar.Create( GetParent(),
		WS_CHILD | WS_VISIBLE | CBRS_TOP | CBRS_TOOLTIPS | CBRS_FLYBY,
		AFX_IDW_TOOLBAR+15))
	{
		TRACE0("Failed to create toolbar 3\n");
		return;      // fail to create
	}
	((CFrameWnd *)GetParent())->ShowControlBar(&(GetDocument()->m_TitleToolBar), TRUE, FALSE);

	// Se il documento non e` vuoto, fa un fit; altrimenti imposta la scala di default dei docs
	if( GetDocument()->m_compArray.GetSize() > 0)
	{
		// Fa un update generale delle regioni
		PRIMARRAY& CompArray = GetDocument()->m_compArray;
		CClientDC dc(this);
		OnPrepareDC( &dc);
		GetDocument()->UpdateBoundingRegions( &dc, CompArray);
	}
	else
	{
		if( GetDocument()->GetID() == IDR_CHILDFRAME)
		{
			SetZoom( DEFAULT_DOCZOOM, FALSE, FALSE, FALSE);
			SetOrigin( CPoint(0,0), FALSE);
		}
		else
		{
			SetZoom( DEFAULT_MACROZOOM, FALSE, FALSE, FALSE);
			SetOrigin( CPoint(XMACRO_ORIG-10,YMACRO_ORIG-10), FALSE);
		}
	}

	// Impostazioni di visualizzazione differenziate per documenti e macro/libs
	if( GetDocument()->GetID() == IDR_CHILDFRAME)
	{
		m_GridDlg.m_bSnapEnable = TRUE;
		m_GridDlg.m_bHideMacroOrigin = TRUE;
	}
	else
	{
		m_GridDlg.m_bSnapEnable = FALSE;
		m_GridDlg.m_bHideMacroOrigin = FALSE;
	}

	if( GetDocument()->m_compArray.GetSize() > 0)
		OnViewFit();
	else
		CView::OnInitialUpdate();
}

void CElecDrawView::OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint) 
{
	// TODO: mah?
	PRIMARRAY& CompArray = GetDocument()->m_compArray;
	CClientDC dc(this);
	OnPrepareDC( &dc);
	GetDocument()->UpdateBoundingRegions( &dc, CompArray);

	SetScrollBars();
	InvalidateRect( NULL, FALSE);
	UpdateWindow();
}

void CElecDrawView::OnSize(UINT nType, int cx, int cy) 
{
	SetScrollBars();
}

void CElecDrawView::SetScrollBars( void)
{
	if( m_bStretch)
	{
		ShowScrollBar( SB_BOTH, FALSE);		// per sicurezza
	}
	else
	{
		m_bScrollRedraw = TRUE;

		CRect rc;
		GetClientRect( &rc);
		CClientDC dc(this);
		OnPrepareDC( &dc);
		dc.DPtoLP( &rc);

		SCROLLINFO si;
		si.cbSize = sizeof( si);
		si.fMask = SIF_PAGE | SIF_RANGE | SIF_POS;
		si.nMin = 0;
		si.nMax = DEFAULT_AREAX;
		si.nPage = rc.Width();
		si.nPos = GetOrigin().x;
		if( si.nPage < (unsigned)si.nMax && si.nPos+si.nPage > (unsigned)si.nMax)
		{
			si.nPos = si.nMax-si.nPage;
			SetOrigin( CPoint(si.nPos, GetOrigin().y), FALSE);
		}
		SetScrollInfo( SB_HORZ, &si);

		si.nMax = DEFAULT_AREAY;
		si.nPage = rc.Height();
		si.nPos = GetOrigin().y;
		if( si.nPage < (unsigned)si.nMax && si.nPos+si.nPage > (unsigned)si.nMax)
		{
			si.nPos = si.nMax-si.nPage;
			SetOrigin( CPoint(GetOrigin().x, si.nPos), FALSE);
		}
		SetScrollInfo( SB_VERT, &si);

		m_bScrollRedraw = FALSE;
	}
}



void CElecDrawView::OnPrepareDC(CDC* pDC, CPrintInfo* pInfo) 
{
	CView::OnPrepareDC(pDC, pInfo);

	if( pDC->IsPrinting())
	{
		// Dimensioni reali (logiche) del disegno
		CRect rcBounding(0,0,DEFAULT_AREAX, DEFAULT_AREAY);
		GetDocument()->GetRealSize( rcBounding);

		if( m_PCBmode)
		{
			int micron_per_ul = ((CMainFrame*)AfxGetMainWnd())->m_dlgConfig.m_mmPerUL;

			CSize PCBsize(	(int)(rcBounding.Width()*micron_per_ul/10),
							(int)(rcBounding.Height()*micron_per_ul/10));
			pDC->HIMETRICtoDP( &PCBsize);
			CSize PCBorg(	(int)(rcBounding.left*micron_per_ul/10),
							(int)(rcBounding.top*micron_per_ul/10));
			pDC->HIMETRICtoDP( &PCBorg);

			// Coord. trasformation
			pDC->SetMapMode( MM_ISOTROPIC);
			pDC->SetWindowExt( rcBounding.Width(), rcBounding.Height());
			pDC->SetWindowOrg( rcBounding.left, rcBounding.top);
			pDC->SetViewportExt( PCBsize.cx, PCBsize.cy);
			pDC->SetViewportOrg( PCBorg.cx, PCBorg.cy);
		}
		else
		{
			// Trova le dimensioni fisiche dell'area di lavoro
			int cx, cy;
			cx = pDC->GetDeviceCaps( HORZSIZE);
			cy = pDC->GetDeviceCaps( VERTSIZE);
			cx *= 100;
			cy *= 100;
			CSize s( cx, cy);
			pDC->HIMETRICtoDP( &s);

			// Considera un bordo di 0.5 cm per lato
			CSize bordo( 500, 500);
			pDC->HIMETRICtoDP( &bordo);

			// Coord. trasformation
			pDC->SetMapMode( MM_ISOTROPIC);
			pDC->SetWindowExt( rcBounding.Width(), rcBounding.Height());
			pDC->SetWindowOrg( rcBounding.left, rcBounding.top);
			pDC->SetViewportExt( s.cx-bordo.cx*2, s.cy-bordo.cy*2);
			pDC->SetViewportOrg( bordo.cx, bordo.cy);
		}
	}
	else
	{
		if( m_bStretch)
		{
			CRect rc;
			GetClientRect( rc);
			pDC->SetMapMode( MM_ANISOTROPIC);
			pDC->SetWindowExt( DEFAULT_AREAX, DEFAULT_AREAY);
			pDC->SetViewportExt( rc.Width(), rc.Height());
			pDC->SetViewportOrg( 0, 0);
		}
		else
		{
			CRect rc;
			GetClientRect( rc);
			pDC->SetMapMode( MM_ISOTROPIC);
			pDC->SetWindowExt( DEFAULT_AREAX, DEFAULT_AREAY);
			pDC->SetViewportExt( (int)(DEFAULT_AREAX*GetZoom()), (int)(DEFAULT_AREAY*GetZoom()));
			pDC->SetViewportOrg( (int)(-GetOrigin().x*GetZoom()), (int)(-GetOrigin().y*GetZoom()));
		}
	}
}

void CElecDrawView::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	CClientDC dc(this);
	CRect rc;
	OnPrepareDC( &dc);
	GetClientRect( &rc);
	dc.DPtoLP( &rc);

	int maxy = DEFAULT_AREAY - rc.Height();
	int dy = 0;

	switch( nSBCode)
	{
		case SB_LINEUP:
			if( GetOrigin().y < (signed)m_GridDlg.m_ysnap)
				dy = -GetOrigin().y;
			else
				dy -= m_GridDlg.m_ysnap;
			break;

		case SB_PAGEUP:
			if( GetOrigin().y < rc.Height())
				dy = -GetOrigin().y;
			else
				dy = -rc.Height();
			break;

		case SB_LINEDOWN:
			if( GetOrigin().y > maxy-(signed)m_GridDlg.m_ysnap)
				dy = maxy-GetOrigin().y;
			else
				dy = m_GridDlg.m_ysnap;
			break;

		case SB_PAGEDOWN:
			if( GetOrigin().y > maxy - rc.Height())
				dy = maxy-GetOrigin().y;
			else
				dy = rc.Height();
			break;

		case SB_THUMBPOSITION:
			dy = nPos - GetOrigin().y;
			break;

		case SB_THUMBTRACK:
			OnVScroll( SB_THUMBPOSITION, nPos, pScrollBar);
			return;
	}

	// Lo spazio di scrolling a fornito in coordinate FISICHE, non logiche. Quindi
	// occorre convertire dy (che e' in coordinate logiche). Non si puo' convertire
	// direttamente, perche' cio' porterebbe a errori di approssimazione; si deve
	// invece calcolare la posizione fisica del grafico prima e dopo che venga
	// spostato. Il "delta" giusto e' la differenza delle due posizioni.
	int ptfirst, ptnext;
	ptfirst = (int)(GetOrigin().y*GetZoom());
	CPoint pt = GetOrigin();
	SetOrigin( CPoint(pt.x, pt.y + dy), FALSE);
	ptnext = (int)(GetOrigin().y*GetZoom());

	SetScrollPos( SB_VERT, GetOrigin().y);
	ScrollWindow( 0, ptfirst-ptnext);

	CView::OnVScroll(nSBCode, nPos, pScrollBar);
}

void CElecDrawView::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	CClientDC dc(this);
	CRect rc;
	OnPrepareDC( &dc);
	GetClientRect( &rc);
	dc.DPtoLP( &rc);

	int maxx = DEFAULT_AREAX - rc.Width();
	int dx = 0;

	switch( nSBCode)
	{
		case SB_LINEUP:
			if( GetOrigin().x < (signed)m_GridDlg.m_xsnap)
				dx = -GetOrigin().x;
			else
				dx -= m_GridDlg.m_xsnap;
			break;

		case SB_PAGEUP:
			if( GetOrigin().x < rc.Width())
				dx = -GetOrigin().x;
			else
				dx = -rc.Width();
			break;

		case SB_LINEDOWN:
			if( GetOrigin().x > maxx-(signed)m_GridDlg.m_xsnap)
				dx = maxx-GetOrigin().x;
			else
				dx = m_GridDlg.m_xsnap;
			break;

		case SB_PAGEDOWN:
			if( GetOrigin().x > maxx - rc.Width())
				dx = maxx-GetOrigin().x;
			else
				dx = rc.Width();
			break;

		case SB_THUMBPOSITION:
			dx = nPos - GetOrigin().x;
			break;

		case SB_THUMBTRACK:
			OnHScroll( SB_THUMBPOSITION, nPos, pScrollBar);
			return;
	}

	int ptfirst, ptnext;
	ptfirst = (int)(GetOrigin().x*GetZoom());
	CPoint pt = GetOrigin();
	SetOrigin( CPoint(pt.x + dx, pt.y), FALSE);
	ptnext = (int)(GetOrigin().x*GetZoom());

	SetScrollPos( SB_HORZ, GetOrigin().x);
	ScrollWindow( ptfirst-ptnext, 0);
	
	CView::OnHScroll(nSBCode, nPos, pScrollBar);
}


/////////////////////////////////////////////////////////////////////////////
// CElecDrawView message handlers


void CElecDrawView::OnViewGrid() 
{
	if( m_GridDlg.DoModal() == IDOK)
		GetDocument()->UpdateAllViews( NULL);
}

void CElecDrawView::OnViewStretch() 
{
	if( m_bStretch == TRUE)
	{
		SetZoom( GetZoom(), FALSE, FALSE, FALSE);
		SetOrigin( CPoint(0,0), TRUE);
	}
	else
	{
		SetZoom( GetZoom(), TRUE, FALSE, FALSE);
		SetOrigin( CPoint(0,0), TRUE);
	}
}

void CElecDrawView::OnUpdateViewStretch(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck( m_bStretch ? 1 : 0);
}

void CElecDrawView::OnViewFit() 
{
	CWaitCursor pippo;
	CRect rcReal(0,0,DEFAULT_AREAX, DEFAULT_AREAY);
	GetDocument()->GetRealSize( rcReal);

	// Ingrandisce del 5%
	rcReal.InflateRect( rcReal.Width()*5/100, rcReal.Height()*5/100);

	CRect rcVisible;
	GetClientRect( &rcVisible);

	double scalex = (double)(rcVisible.Width()) / rcReal.Width();
	double scaley = (double)(rcVisible.Height()) / rcReal.Height();
	double scale = MINIMO(scalex, scaley);

	m_bStretch = FALSE;
	SetZoom( scale, FALSE, TRUE, FALSE);
	SetOrigin( CPoint( rcReal.left, rcReal.top), FALSE);
	SetScrollBars();
	InvalidateRect( NULL);
	UpdateWindow();
}

void CElecDrawView::OnButtonGotoorigin() 
{
	SetOrigin( CPoint(XMACRO_ORIG-10,YMACRO_ORIG-10), TRUE);
}

void CElecDrawView::OnButtonSnap() 
{
	m_GridDlg.m_bSnapEnable = !m_GridDlg.m_bSnapEnable;	
}

void CElecDrawView::OnUpdateButtonSnap(CCmdUI* pCmdUI) 
{
	if( m_GridDlg.m_bSnapEnable)
		pCmdUI->SetCheck( 1);
	else
		pCmdUI->SetCheck( 0);
}

void CElecDrawView::OnButtonPcbmode() 
{
	m_PCBmode = !m_PCBmode;
}

void CElecDrawView::OnUpdateButtonPcbmode(CCmdUI* pCmdUI) 
{
	if( m_PCBmode)
		pCmdUI->SetCheck( 1);
	else
		pCmdUI->SetCheck( 0);
}

void CElecDrawView::SetZoom( double factor, BOOL bStretch, BOOL bFit, BOOL bRedraw)
{
	double oldzoom = m_ZoomFact;
	BOOL bOldStretch = m_bStretch;

	// Adattamenti
	if( factor*100.0 < MIN_ZOOM)
		factor = MIN_ZOOM/100.0;
	if( factor*100.0 > MAX_ZOOM)
		factor = MAX_ZOOM/100.0;

	CWaitCursor pippo;
	m_bStretch = bStretch;
	m_ZoomFact = factor;

	if( bStretch && bFit)
		m_bStretch = FALSE;			// Potere al fit!

	// Aggiorna le bounding regions se e' necessario
	if( m_ZoomFact != oldzoom || bFit || m_bStretch != bOldStretch)
	{
		PRIMARRAY& CompArray = GetDocument()->m_compArray;
		PRIMARRAY& SelArray = GetDocument()->m_selArray;
		CClientDC dc(this);
		OnPrepareDC( &dc);
		int a, n=CompArray.GetSize();
		CPrimitive *p;
		for( a=0; a<n; a++)
		{
			p = CompArray.GetAt(a);
			if( p->GetProp() & PROP_UPDATEONZOOM)
				p->UpdateBoundingRgn( &dc);
		}
	}

	if( bRedraw)
	{
		SetScrollBars();
		((CElecDrawDoc *)GetDocument())->UpdateAllViews( NULL);
	}

	CViewToolBar* toolbar = &(GetDocument()->m_TitleToolBar);
	CString str;
	str.Format( "%d%%", (int)(m_ZoomFact*100));
	toolbar->m_ComboZoom.SetWindowText( str);
}

double CElecDrawView::GetZoom( void)
{
	return m_ZoomFact;
}

void CElecDrawView::OnComboZoomEditChange()
{
	// Ritrova la toolbar
	CViewToolBar* toolbar = &(GetDocument()->m_TitleToolBar);

	CString str;
	toolbar->m_ComboZoom.GetWindowText( str);
	if( str.Find("%") == -1)
		return;

	int zoom = atoi( LPCSTR(str));
	if( zoom >= MIN_ZOOM && zoom <= MAX_ZOOM)
	{
		SetZoom( zoom/100.0, FALSE, FALSE, FALSE);
		SetOrigin( CPoint(0,0), TRUE);
		SetFocus();
	}
}

void CElecDrawView::OnComboZoomSelChange()
{
	// Ritrova la toolbar
	CViewToolBar* toolbar = &(GetDocument()->m_TitleToolBar);

	int indx = toolbar->m_ComboZoom.GetCurSel();
	if( indx != CB_ERR)
	{
		CString str;
		toolbar->m_ComboZoom.GetLBText( indx, str);
		int zoom = atoi( LPCSTR(str));
		if( zoom >= MIN_ZOOM && zoom <= MAX_ZOOM)
		{
			SetZoom( zoom/100.0, FALSE, FALSE, FALSE);
			SetOrigin( CPoint(0,0), TRUE);
			SetFocus();
		}
	}
}

void CElecDrawView::SetOrigin( CPoint ptOrigin, BOOL bRedraw)
{
	m_Origin = ptOrigin;

	if( bRedraw)
	{
		SetScrollBars();
		((CElecDrawDoc *)GetDocument())->UpdateAllViews( NULL);
	}
}

CPoint CElecDrawView::GetOrigin( void)
{
	return m_Origin;
}

void CElecDrawView::OnTimer(UINT nIDEvent) 
{
	if( nIDEvent != 1)
	{
		CView::OnTimer(nIDEvent);
		return;
	}

	if( (m_bRectangleSel || m_bChanging || m_bMoving) && !m_bStretch)
	{
		SCROLLINFO sih, siv;
		SCROLLINFO sih2, siv2;
		POINT pt;
		GetScrollInfo( SB_HORZ, &sih);
		GetScrollInfo( SB_VERT, &siv);

		if( m_BorderProximity & BORD_LEFT && sih.nPos > sih.nMin)
			OnHScroll( SB_LINEUP, sih.nPos, GetScrollBarCtrl( SB_HORZ));
		else if( m_BorderProximity & BORD_RIGHT && sih.nPos < sih.nMax)
			OnHScroll( SB_LINEDOWN, sih.nPos, GetScrollBarCtrl( SB_HORZ));
		
		if( m_BorderProximity & BORD_TOP && siv.nPos > siv.nMin)
			OnVScroll( SB_LINEUP, siv.nPos, GetScrollBarCtrl( SB_HORZ));
		else if( m_BorderProximity & BORD_BOTTOM && siv.nPos < siv.nMax)
			OnVScroll( SB_LINEDOWN, siv.nPos, GetScrollBarCtrl( SB_HORZ));

		GetScrollInfo( SB_HORZ, &sih2);
		GetScrollInfo( SB_VERT, &siv2);

		if( sih2.nPos != sih.nPos || siv2.nPos != siv.nPos)
		{
			PRIMARRAY& SelArray = GetDocument()->m_selArray;
			CClientDC dc(this);
			OnPrepareDC( &dc);

			HideGroup( SelArray);
			// GetDocument()->UpdateAllViews( NULL);
			if( m_bRectangleSel)
			{
				CRect rcNormalized = m_rcSel;
				rcNormalized.NormalizeRect();
				DrawSelRect( dc, rcNormalized);
			}
			else
				RedrawGroup( SelArray, TRUE, FALSE);

			::GetCursorPos( &pt);
			ScreenToClient( &pt);
			OnMouseMove( 0, CPoint(pt));
		}
	}

	// Sempre piu' veloce
	m_nTimerTicks++;
	if( m_nTimerTicks == 4)
		SetTimer( 1, 250, NULL);
	else if( m_nTimerTicks == 12)
		SetTimer( 1, 125, NULL);
	else if( m_nTimerTicks == 28)
		SetTimer( 1, 62, NULL);
}

void CElecDrawView::OnViewRefresh() 
{
	GetDocument()->UpdateAllViews( NULL);
}

void CElecDrawView::OnEditClear() 
{
	if( m_bRectangleSel || m_bChanging || m_bMoving || m_bDragging)
		return;

	SetFocus();

	PRIMARRAY& SelArray = GetDocument()->m_selArray;
	PRIMARRAY& CompArray = GetDocument()->m_compArray;
	CWaitCursor pippo;
	
	// Va alla ricerca degli ogg. selezionati
	int a, n=SelArray.GetSize();
	int b, m=CompArray.GetSize();

	if( n==0)
		return;

	for( a=0; a<n; a++)
		for( b=0; b<m; b++)
		{
			if( CompArray[b] == SelArray[a])
			{
				delete CompArray[b];
				CompArray.RemoveAt(b);
				m--;
				break;
			}
		}
	
	SelArray.RemoveAll();
	GetDocument()->SetModifiedFlag();
	GetDocument()->UpdateAllViews( NULL);

	// Inserisce lo step nell'undo buffer
	GetDocument()->UndoStore();
}

void CElecDrawView::OnUpdateEditClear(CCmdUI* pCmdUI) 
{
	PRIMARRAY& SelArray = GetDocument()->m_selArray;
	pCmdUI->Enable( (SelArray.GetSize()>0) ? TRUE : FALSE);
}

void CElecDrawView::OnEditCopy() 
{
	if( m_bRectangleSel || m_bChanging || m_bMoving || m_bDragging)
		return;

	SetFocus();

	PRIMARRAY& SelArray = GetDocument()->m_selArray;
	CWaitCursor pippo;

	// Prepara il buffer...
	CString clip="[FIDOCAD]\r\n", temp, txt;	// TODO
	int a,n=SelArray.GetSize();
	CPrimitive *p;
	BOOL bSplit = ((CMainFrame *)AfxGetMainWnd())->m_dlgConfig.m_bSaveMacro;
	for( a=0; a<n; a++)
	{
		p = SelArray[a];
		p->GetAttrib( "Text", txt);
		if( p->GetProp() & PROP_ISMACRO && 
			txt.GetLength() > 0 && txt.GetAt(0) == '~')
				p->Save( temp);
		else
				p->Save( temp, bSplit);

		clip += temp;
	}

	// ... lo inserisce in un blocco globale...
	HGLOBAL h;
	void *lock;
	if( (h = ::GlobalAlloc( GMEM_MOVEABLE | GMEM_DDESHARE, clip.GetLength()+1)) == NULL ||
		(lock = ::GlobalLock( h)) == NULL)
	{
		MessageBeep( MB_ICONERROR);
		return;
	}

	// ...copia la stringa.
	::MoveMemory( lock, LPCSTR(clip), clip.GetLength()+1);
	::GlobalUnlock( h);

	// Apre la clipboard
	if( !(AfxGetMainWnd()->OpenClipboard()))
	{
		MessageBeep( MB_ICONEXCLAMATION);
		return;
	}
	
	// La svuota
	::EmptyClipboard();

	// Ci copia il blocco
	::SetClipboardData( CF_TEXT, h);
	::CloseClipboard();
}

void CElecDrawView::OnUpdateEditCopy(CCmdUI* pCmdUI) 
{
	PRIMARRAY& SelArray = GetDocument()->m_selArray;
	if( SelArray.GetSize() > 0)
		pCmdUI->Enable( TRUE);
	else
		pCmdUI->Enable( FALSE);
}

void CElecDrawView::OnEditCut() 
{
	if( m_bRectangleSel || m_bChanging || m_bMoving || m_bDragging)
		return;

	OnEditCopy();
	OnEditClear();
	GetDocument()->SetModifiedFlag();

	// Qui e` inutile mettere l'undo, perche` ci ha gia` pensato OnEditClear()!
}

void CElecDrawView::OnUpdateEditCut(CCmdUI* pCmdUI) 
{
	OnUpdateEditCopy( pCmdUI);
}

void CElecDrawView::OnUpdateEditPaste(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(	IsClipboardFormatAvailable( CF_TEXT));
}

void CElecDrawView::OnEditPaste() 
{
	if( m_bRectangleSel || m_bChanging || m_bMoving || m_bDragging)
		return;

	SetFocus();

	PRIMARRAY& CompArray = GetDocument()->m_compArray;
	PRIMARRAY& SelArray = GetDocument()->m_selArray;

	CWaitCursor pippo;
	PRIMARRAY ar;
	if( CPrimitive::ScanClipboard( ar, AfxGetMainWnd(), NULL))
	{
		DeselectAllObjects( CompArray, SelArray);

		if( ar.GetSize() == 0)
			return;
		
		// Aggiunge gli oggetti agli array
		int a, n = ar.GetSize();
		for( a=0; a<n; a++)
		{
			ar[a]->Select();
			SelArray.Add( ar[a]);
		}

		// Aggiorna le bounding regions
		CClientDC dc(this);
		OnPrepareDC( &dc);
		GetDocument()->UpdateBoundingRegions( &dc, SelArray);

		// Simula una fase di spostamento
		SetCapture();
		RedrawGroup( SelArray, TRUE, FALSE);
		SaveStates( SelArray);
		m_bMoving = TRUE;
		m_bSecca = TRUE;
		m_ClickPoint = m_ActualPoint = m_OldPoint = ar[0]->GetPoint(0);
		m_nRotations = 0;
		m_bSwap = FALSE;
	}
}

void CElecDrawView::OnEditRotate() 
{
	if( m_bMoving || m_bRectangleSel || m_bChanging || m_bDragging)
		return;

	SetFocus();
	PRIMARRAY& SelArray = GetDocument()->m_selArray;
	CPoint pt = FindMiddlePoint( SelArray);
	SnapPoint( pt);
	RotateGroup( SelArray, pt);
	CClientDC dc(this);
	OnPrepareDC( &dc);
	GetDocument()->UpdateBoundingRegions( &dc, SelArray);
	GetDocument()->SetModifiedFlag();
	GetDocument()->UpdateAllViews( NULL);

	// Inserisce lo step nell'undo buffer
	GetDocument()->UndoStore();
}

void CElecDrawView::OnUpdateEditRotate(CCmdUI* pCmdUI) 
{
	PRIMARRAY& SelArray = GetDocument()->m_selArray;
	if( SelArray.GetSize() > 0)
		pCmdUI->Enable( TRUE);
	else
		pCmdUI->Enable( FALSE);
}

void CElecDrawView::OnEditSwap() 
{
	if( m_bMoving || m_bRectangleSel || m_bChanging || m_bDragging)
		return;

	SetFocus();
	PRIMARRAY& SelArray = GetDocument()->m_selArray;
	CPoint pt = FindMiddlePoint( SelArray);
	SnapPoint( pt);
	SwapGroup( SelArray, pt.x);
	CClientDC dc(this);
	OnPrepareDC( &dc);
	GetDocument()->UpdateBoundingRegions( &dc, SelArray);
	GetDocument()->SetModifiedFlag();
	GetDocument()->UpdateAllViews( NULL);

	// Inserisce lo step nell'undo buffer
	GetDocument()->UndoStore();
}

void CElecDrawView::OnUpdateEditSwap(CCmdUI* pCmdUI) 
{
	PRIMARRAY& SelArray = GetDocument()->m_selArray;
	if( SelArray.GetSize() > 0)
		pCmdUI->Enable( TRUE);
	else
		pCmdUI->Enable( FALSE);
}

CPoint CElecDrawView::FindMiddlePoint( PRIMARRAY& SelArray)
{
	int a, n=SelArray.GetSize();
	int b, m;
	int minx = DEFAULT_AREAX*2;
	int miny = DEFAULT_AREAY*2;
	int maxx = -DEFAULT_AREAX;
	int maxy = -DEFAULT_AREAY;

	CPrimitive* p;
	CPoint pt;
	for( a=0; a<n; a++)
	{
		p = SelArray.GetAt(a);
		m = p->GetNumDefPoints();
		for( b=0; b<m; b++)
		{
			pt = p->GetPoint(b);
			if( pt.x < minx)
				minx = pt.x;
			if( pt.x > maxx)
				maxx = pt.x;
			if( pt.y < miny)
				miny = pt.y;
			if( pt.y > maxy)
				maxy = pt.y;
		}
	}

	return CPoint( minx+(maxx-minx)/2, miny+(maxy-miny)/2);
}

void CElecDrawView::OnEditCreamacro() 
{
	if( m_bRectangleSel || m_bChanging || m_bMoving || m_bDragging)
		return;
	
	SetFocus();

	PRIMARRAY& CompArray = GetDocument()->m_compArray;
	PRIMARRAY& SelArray = GetDocument()->m_selArray;
	CWaitCursor pippo;

	CPoint orig = SelArray[0]->GetPoint(0);
	CMacro *m = new CMacro( orig);
	PRIMARRAY* MacroArray = m->GetComponentArray();

	int a, n=CompArray.GetSize();
	CPrimitive *p;
	for( a=0; a<n; a++)
	{
		p = CompArray.GetAt(a);
		if( p->IsSelected())
		{
			p->SetConst();
			p->Select( FALSE);
			//p->MoveRel( CPoint( -orig.x, -orig.y));
			MacroArray->Add( p);
			CompArray.RemoveAt( a);
			a--; n--;
		}
	}

	CClientDC dc( this);
	OnPrepareDC( &dc);
	m->Select();
	m->UpdateBoundingRgn( &dc);
	CompArray.Add( m);
	UpdateSelArray( CompArray, SelArray);
	GetDocument()->UpdateAllViews( NULL);
}

void CElecDrawView::OnUpdateEditCreamacro(CCmdUI* pCmdUI) 
{
	PRIMARRAY& SelArray = GetDocument()->m_selArray;
	if( SelArray.GetSize() > 1)
		pCmdUI->Enable( TRUE);
	else
		pCmdUI->Enable( FALSE);
}

void CElecDrawView::OnEditSplitmacro() 
{
	if( m_bRectangleSel || m_bChanging || m_bMoving || m_bDragging)
		return;

	SetFocus();
	PRIMARRAY& CompArray = GetDocument()->m_compArray;
	PRIMARRAY& SelArray = GetDocument()->m_selArray;
	PRIMARRAY* MacroArray;
	CWaitCursor pippo;
	
	// Splitting, un solo passaggio
	int a, n = SelArray.GetSize();
	int b, m;
	CPrimitive *p, *q;
	CMacro *macro;
	CString ciro;
	BOOL bChanged = FALSE;
	for( a=0; a<n; a++)
	{
		p = SelArray.GetAt(a);
		if( !(p->GetProp() & PROP_ISMACRO))
			continue;

		macro = (CMacro *)p;

		// Setta il flag modifica solo per macro, non per i gruppi
		CString txt;
		macro->GetAttrib( "Text", txt);
		if( txt.Compare(""))
		{
			GetDocument()->SetModifiedFlag();
			bChanged = TRUE;
		}

		// Elimina la macro dagli array
		SelArray.RemoveAt( a); a--; n--;
		m = CompArray.GetSize();
		for( b=0; b<m; b++)
		{
			q = CompArray.GetAt(b);
			if( q == p)
			{
				CompArray.RemoveAt(b);
				break;
			}
		}

		// Splitta la macro
		MacroArray = macro->GetComponentArray();
		m = MacroArray->GetSize();
		for( b=0; b<m; b++)
		{
			q = MacroArray->GetAt(b);
			q->Select();
			q->SetConst( FALSE);
			CompArray.Add( q);
		}

		// Cancella la macro
		MacroArray->RemoveAll();
		delete macro;
	}

	// Aggiorna l'array degli oggetti selezionati
	UpdateSelArray( CompArray, SelArray);
	CClientDC dc(this);
	OnPrepareDC( &dc);
	GetDocument()->UpdateBoundingRegions( &dc, SelArray);
	GetDocument()->UpdateAllViews( NULL);

	// Se necessario, inserisce lo step nell'undo buffer
	if( bChanged)
		GetDocument()->UndoStore();
}

void CElecDrawView::OnUpdateEditSplitmacro(CCmdUI* pCmdUI) 
{
	PRIMARRAY& SelArray = GetDocument()->m_selArray;
	if( SelArray.GetSize() > 0)
		pCmdUI->Enable( TRUE);
	else
		pCmdUI->Enable( FALSE);
}

void CElecDrawView::UpdateSelArray( PRIMARRAY& CompArray, PRIMARRAY& SelArray)
{
	SelArray.RemoveAll();
	
	int a, n=CompArray.GetSize();
	CPrimitive *p;
	for( a=0; a<n; a++)
	{
		p = CompArray.GetAt(a);
		if( p->IsSelected())
			SelArray.Add( p);
	}
}

void CElecDrawView::UpdateCompArray( PRIMARRAY& CompArray, PRIMARRAY& SelArray)
{	
	int a, b, n=SelArray.GetSize(), m=CompArray.GetSize();
	CPrimitive *ps, *pc;
	for( a=0; a<n; a++)
	{
		ps = SelArray.GetAt(a);
		for( b=0; b<m; b++)
		{
			pc = CompArray.GetAt(b);
			if( pc == ps)
				break;
		}
		if( b==m)
			CompArray.Add( ps);
	}
}

void CElecDrawView::OnEditSelectAll() 
{
	if( m_bRectangleSel || m_bChanging || m_bMoving || m_bDragging)
		return;

	SetFocus();
	PRIMARRAY& CompArray = GetDocument()->m_compArray;
	PRIMARRAY& SelArray = GetDocument()->m_selArray;
	CWaitCursor pippo;

	SelArray.RemoveAll();
	int a, m=CompArray.GetSize();
	CPrimitive *p;
	for( a=0; a<m; a++)
	{
		p = CompArray.GetAt(a);

		// Non seleziono i componenti invisibili
		if( !IsComponentVisible( p))
			continue;

		p->Select();
		SelArray.Add( p);
	}

	GetDocument()->UpdateAllViews( NULL);
}

void CElecDrawView::OnEditInvert() 
{
	if( m_bRectangleSel || m_bChanging || m_bMoving || m_bDragging)
		return;

	SetFocus();

	PRIMARRAY& CompArray = GetDocument()->m_compArray;
	PRIMARRAY& SelArray = GetDocument()->m_selArray;
	CWaitCursor pippo;

	int a, m=CompArray.GetSize();
	CPrimitive *p;
	for( a=0; a<m; a++)
	{
		p = CompArray.GetAt(a);
		if( p->IsSelected())
			p->Select( FALSE);
		else if( IsComponentVisible( p))	// Non seleziono i componenti invisibili
			p->Select();
	}

	UpdateSelArray( CompArray, SelArray);
	GetDocument()->UpdateAllViews( NULL);
}


/////////////////////////////////////////////////////////////////////////////
// Gestione degli eventi del mouse
/////////////////////////////////////////////////////////////////////////////


void CElecDrawView::OnLButtonDown( UINT nFlags, CPoint point) 
{	
	m_OldRawPoint = point;

	PRIMARRAY& CompArray = GetDocument()->m_compArray;
	PRIMARRAY& SelArray = GetDocument()->m_selArray;
	PROXIMITY_TYPE prox;
	BOOL bRotating = FALSE;

	CClientDC dc(this);
	OnPrepareDC( &dc);
	CPoint ptRaw = point;
	dc.DPtoLP( &point);

	// Se stiamo facendo qualcosa, ignora il messaggio
	if( m_bChanging || m_bMoving || m_bRectangleSel || m_bDragging)
		return;

	// Gestisce lo snap
	SnapPoint( point);

	// Il click point!
	m_ClickPoint = m_ActualPoint = m_OldPoint = point;
	m_nRotations = 0;
	m_bSwap = FALSE;

	// Verifica se siamo in drag mode
	if( ((CMainFrame *)AfxGetMainWnd())->m_SelectedPrimitive == B_DRAG)
	{
		// TODO
		SetCapture();
		m_bDragging = TRUE;
		::SetCursor( m_DragClosedCursor);
		return;
	}

	// Verifica se siamo in modalita' zoom
	if( ((CMainFrame *)AfxGetMainWnd())->m_SelectedPrimitive == B_ZOOM)
	{
		CPoint neworig;
		CalcNewOrigin( dc, neworig, point, GetZoom()*MAGSTEP);
		SetOrigin( neworig, FALSE);
		SetZoom( GetZoom()*MAGSTEP, FALSE, FALSE, TRUE);
		return;
	}

	// Verifica se si desidera la modalita' rotativa
	if( ::GetAsyncKeyState( VK_MENU) & 0x8000)
		bRotating = TRUE;

	// Scorre in rassegna tutti gli oggetti del documento (prima quelli selezionati;
	// poi fa anche una rotazione degli oggetti vicini, se e' stato richiesto)
	CPrimitive *p, *pPrimitive = NULL, *firstSel = NULL;
	int a, l = CompArray.GetSize(), prev = -1, newfirst = -1;
	for( a=0; a<l; a++)
	{
		p = CompArray[a];

		// Ignora i componenti nascosti
		if( !IsComponentVisible( p))
			continue;

		if( (prox = p->IsPtNear( ptRaw, &dc)) != NEAR_NONE)
		{
			if( pPrimitive == NULL)
				pPrimitive = p;

			if( p->IsSelected() && firstSel == NULL)
				firstSel = p;

			if( !bRotating)
				continue;

			if( prev != -1)
			{
				CompArray[prev] = CompArray[a];
				if( newfirst == -1)
					newfirst = prev;
			}

			prev = a;
		}
	}

	if( prev != -1)
		CompArray[prev] = pPrimitive;

	if( firstSel != NULL && !bRotating)
		pPrimitive = firstSel;

	if( newfirst != -1)
		pPrimitive = CompArray[newfirst];

	// 3 casi: Ho cliccato con la dragging hand, ho cliccato sul nulla (pPrimitive==NULL)
	// oppure ho cliccato su un oggetto col selezionatore
	if( pPrimitive == NULL || ((CMainFrame *)AfxGetMainWnd())->m_SelectedPrimitive != B_NONE)
	{
		// Selezione a rettangolo
		if( ((CMainFrame *)AfxGetMainWnd())->m_SelectedPrimitive == B_NONE)	
		{
			// Se non e' premuto CTRL e ci sono ogg. selezionati, deseleziona tutto
			if( !(::GetAsyncKeyState( VK_CONTROL) & 0x8000) &&
				SelArray.GetSize() != 0)
					DeselectAllObjects( CompArray, SelArray);

			SetCapture();
			m_bRectangleSel = TRUE;
			m_rcSel = CRect( m_ClickPoint, m_ClickPoint);
			DrawSelRect( dc, m_rcSel);
			return;
		}
		// inserimento nuovo componente
		else
		{
			CPrimitive* pri;
			switch( ((CMainFrame *)AfxGetMainWnd())->m_SelectedPrimitive)
			{
				case B_LINE:
					pri = new CLine( point);
					break;

				case B_EXTENDEDTEXT:
					pri = new CExtendedText( point, "Testo");
					break;

				case B_CONNECTION:
					pri = new CConnection( point);
					break;

				case B_BEZIER:
					pri = new CBezier( point);
					break;

				case B_POLY:
					pri = new CPoly( point);
					break;

				case B_ELLIPSE:
					pri = new CEllipse( point);
					break;

				case B_RECTANGLE:
					pri = new CRectangle( point);
					break;

				case B_VIA:
					pri = new CPCBLine( point);
					break;

				case B_PAD:
					pri = new CPCBPad( point);
					break;

				case B_MACRO:
				{
					// Trova l'oggetto selezionato nella dialog bar
					CString* macrosel = ((CMainFrame*)AfxGetMainWnd())->m_wndDlgMacroBar.GetSelectedMacro();
					if( macrosel == NULL)
					{
						MessageBeep(0);
						return;
					}

					pri = new CMacro();

					// Legge la macro
					if( !CMacro::ScanMacroName( *macrosel, (CMacro&)(*pri), NULL, NULL))
					{
						MessageBeep(0);
						delete pri;
						return;
					}

					// Aggiustamenti
					CClientDC dc(this);
					OnPrepareDC( &dc);
					((CMacro*)pri)->Adjust();
					pri->SetPoint( 0, point);
					pri->UpdateBoundingRgn( &dc);
				}
					break;

				default: ASSERT( FALSE);
			}

			/* Imposta il layer in base alla combo del layer */
			pri->SetLayer( ((CMainFrame*)AfxGetMainWnd())->GetCurrentLayer());

			// Deseleziona tutto
			SetCapture();
			m_bChanging = TRUE;
			m_bNew = TRUE;
			DeselectAllObjects( CompArray, SelArray);

			pri->Select();
			SelArray.Add( pri);
			CompArray.Add( pri);	// TODO???
			SaveStates( SelArray);

			// Tenta un primo disegno
			pri->Draw( &dc, TRUE);

			// Il prossimo punto da cambiare dipende da quanti punti e' composta
			// la primitiva
			if( pri->GetNumDefPoints() == 1)
				m_nPointToChange = 0;
			else
				m_nPointToChange = 1;
		}
	}
	// Ho cliccato su qualcosa con il selezionatore
	else
	{
		prox = pPrimitive->IsPtNear( ptRaw, &dc);

		// Se non e' premuto CTRL e se non ho cliccato su un oggetto gia'
		// selezionato e se c'e' qualcosa di selezionato, deseleziono il resto
		if( !(::GetAsyncKeyState( VK_CONTROL) & 0x8000) &&
			!(pPrimitive->IsSelected()) &&
			SelArray.GetSize() != 0)
				DeselectAllObjects( CompArray, SelArray, TRUE);

		// Se e' premuto CTRL e ho cliccato su un oggetto selezionato, lo deseleziono
		if( (::GetAsyncKeyState( VK_CONTROL) & 0x8000) && pPrimitive->IsSelected())
		{
			pPrimitive->Select( FALSE);
			UpdateSelArray( CompArray, SelArray);
			GetDocument()->UpdateAllViews( NULL);
			return;
		}
			
		// Seleziona l'oggetto (se non era gia' sel.)
		if( pPrimitive->IsSelected() == FALSE)
		{
			pPrimitive->Select();
			SelArray.Add( pPrimitive);

			// Se la primitiva e` puzzolente, dobbiamo ridisegnare
			if( pPrimitive->GetProp() & PROP_ERASEONSELECT)
				GetDocument()->UpdateAllViews( NULL);
			else
				RedrawGroup( SelArray, FALSE, TRUE);
		}

		// Se c'e' piu' di un oggetto selezionato l'unica operazione che si puo'
		// fare e' lo spostamento di gruppo; se c'e' un solo oggetto si puo' anche
		// modificare, a patto che non sia di tipo const e che non sia composto da
		// un solo punto di definizione
		if( SelArray.GetSize() > 1 || prox == NEAR_BODY ||
			(SelArray.GetSize() == 1 
			&& SelArray[0]->GetNumDefPoints() == 1))
		{
			m_bMoving = TRUE;
			SetCapture();
			SaveStates( SelArray);
			m_bMoveFirst = TRUE;
		}
		else if( (int)prox >= (int)NEAR_SELECTOR_0)
		{
			SetCapture();
			m_bChanging = TRUE;
			m_nPointToChange = (int)prox;
			SaveStates( SelArray);
			HideGroup( SelArray);
			RedrawGroup( SelArray, TRUE, FALSE);
		}
		else
			GetDocument()->UpdateAllViews( NULL);
	}
}

void CElecDrawView::OnMouseMove(UINT nFlags, CPoint point) 
{
	m_OldRawPoint = point;

	PRIMARRAY& CompArray = GetDocument()->m_compArray;
	PRIMARRAY& SelArray = GetDocument()->m_selArray;

	// Se siamo in qualche modalita' e siamo vicini al bordo della client,
	// attiva il timer dello spostamento
	if( m_bRectangleSel || m_bChanging || m_bMoving && !m_bMoveFirst)
	{
		CRect rc;
		GetClientRect( &rc);

		m_BorderProximity = 0;
		if( ABS(rc.top-point.y) < BORDER_PROXIMITY)
			m_BorderProximity |= BORD_TOP;
		else if( ABS(rc.bottom-point.y) < BORDER_PROXIMITY)
			m_BorderProximity |= BORD_BOTTOM;
		if( ABS(rc.left-point.x) < BORDER_PROXIMITY)
			m_BorderProximity |= BORD_LEFT;
		else if( ABS(rc.right-point.x) < BORDER_PROXIMITY)
			m_BorderProximity |= BORD_RIGHT;

		if( m_BorderProximity != 0)
		{
			if( !m_bTimer)
			{
				m_bTimer = TRUE;
				m_nTimerTicks = 0;
				SetTimer( 1, 500, NULL);
				return;
			}
		}
		else if( m_bTimer)
		{
			KillTimer( 1);
			m_bTimer = FALSE;
		}
	}

	CClientDC dc(this);
	OnPrepareDC( &dc);
	CPoint ptRaw = point;
	dc.DPtoLP( &point);

	// Gestisce lo snap
	if( !m_bDragging)
		SnapPoint( point);

	// Verifica che ci sia stato uno spostamento "vero"
	if( (m_bRectangleSel || m_bChanging || m_bMoving || m_bDragging) && point == m_OldPoint)
		return;

	// Visualizza la posizione del cursore (anche pos. fisiche)
	CString panetxt;
	int mpul = ((CMainFrame*)AfxGetMainWnd())->m_dlgConfig.m_mmPerUL;
	panetxt.Format( "(%d,%d) (%.2f mm, %.2f mm)", point.x, point.y,
		(double)point.x*mpul/1000, (double)point.y*mpul/1000);
	((CMainFrame *)AfxGetMainWnd())->m_wndStatusBar.SetPaneText( 0, panetxt);

	if( m_bDragging)
	{
		// TODO
		// Per capire come devo spostare il disegno, devo considerare l'origine di
		// visualizzazione di quando ho iniziato a trascinarlo. Se considerassi quella
		// attuale, ci sarebbe una retroazione maligna!
		// (non posso crederci, mezza giornata buttata per un problema di merda del genere)
		int cx = point.x - m_OldPoint.x;
		int cy = point.y - m_OldPoint.y;

		CPoint ptfirst, ptnext;
		CPoint orig = GetOrigin();
		ptfirst.x = (int)(orig.x*GetZoom());
		ptfirst.y = (int)(orig.y*GetZoom());
		SetOrigin( CPoint( orig.x - cx, orig.y - cy), FALSE);
		orig = GetOrigin();
		ptnext.x = (int)(orig.x*GetZoom());
		ptnext.y = (int)(orig.y*GetZoom());

		SetScrollPos( SB_HORZ, orig.x);
		SetScrollPos( SB_VERT, orig.y);

		m_OldPoint.x = point.x - cx;
		m_OldPoint.y = point.y - cy;

		ScrollWindow( ptfirst.x-ptnext.x, ptfirst.y-ptnext.y);
		UpdateWindow();
	}
	else if( m_bRectangleSel)
	{
		// Cancella il vecchio rettangolo
		CRect rcNormalized = m_rcSel;
		rcNormalized.NormalizeRect();
		DrawSelRect( dc, rcNormalized);
		rcNormalized = m_rcSel = CRect( m_ClickPoint, point);
		rcNormalized.NormalizeRect();
		m_OldPoint = point;
		DrawSelRect( dc, rcNormalized);
	}
	else if( m_bChanging)
	{
		CPrimitive *p = SelArray[0];
		p->Draw( &dc, TRUE);
		p->SetPoint( m_nPointToChange, point);
		m_OldPoint = point;
		p->Draw( &dc, TRUE);
	}
	else if( m_bMoving)
	{
		if( m_bMoveFirst)
		{
			HideGroup( SelArray);
			m_bMoveFirst = FALSE;
		}
		else
			RedrawGroup( SelArray, TRUE, FALSE);

		int a, n=SelArray.GetSize();
		CPrimitive *p;
		CPoint ptrel = point-m_OldPoint;
		for( a=0; a<n; a++)
		{
			p = SelArray[a];
			p->MoveRel( ptrel);
		}
		m_OldPoint = point;
		RedrawGroup( SelArray, TRUE, FALSE);
	}
	else if( ((CMainFrame *)AfxGetMainWnd())->m_SelectedPrimitive == B_NONE)
	{
		PROXIMITY_TYPE prox;
		int a, l = SelArray.GetSize();
		for( a=0; a<l; a++)
		{
			prox = SelArray[a]->IsPtNear( ptRaw, &dc);
			switch( prox)
			{
				case NEAR_NONE:
					break;

				case NEAR_BODY:
					::SetCursor( m_MoveCursor);
					break;

				default:
					if( l == 1)
						::SetCursor( m_SizeCursor);
					else
						::SetCursor( m_MoveCursor);
					break;
			}

			if( prox != NEAR_NONE)
				break;
		}

		if( a==l)
			::SetCursor( m_NormCursor);
	}
}

void CElecDrawView::OnRButtonUp(UINT nFlags, CPoint point) 
{
	PRIMARRAY& CompArray = GetDocument()->m_compArray;
	PRIMARRAY& SelArray = GetDocument()->m_selArray;
	CPoint backup = point;

	CClientDC dc(this);
	OnPrepareDC( &dc);
	CPoint ptRaw = point;
	dc.DPtoLP( &point);

	// Gestisce lo snap
	SnapPoint( point);

	// Elimina tutte le modifiche o ruota, a seconda dell'ambaradan
	if( m_bRectangleSel)
	{
		m_bRectangleSel = m_bJustKill = FALSE;
		DrawSelRect( dc, m_rcSel);
		::ReleaseCapture();
	}
	else if( m_bChanging)
	{
		CPrimitive *p = SelArray[0];
		int b,m = CompArray.GetSize();

		// Se l'oggetto e' ruotabile e necessita di un solo punto, lo ruoto
		if( (p->GetProp() & (PROP_ROTATEFULL | PROP_ROTATEHALF)) && 
			(p->GetNumDefPoints() == 1) &&
			!m_bJustKill)
		{
			p->Draw( &dc, TRUE);
			RotateGroup( SelArray, point);
			
			// Il numero di rot. cala o cresce a seconda dello swap
			if( !m_bSwap)
				m_nRotations++;
			else
				m_nRotations--;
			if( m_nRotations < 0)
				m_nRotations += 4;
			if( m_nRotations > 3)
				m_nRotations -= 4;
			
			p->Draw( &dc, TRUE);
			return;
		}

		if( p->GetPoint( m_nPointToChange).x != -1 || p->GetPoint( m_nPointToChange).y != -1)
			p->Draw( &dc, TRUE);
		
		m_bChanging = m_bMoving = m_bJustKill = FALSE;
		::ReleaseCapture();

		// Se l'oggetto era inizialmente indefinito, va distrutto.
		if( m_bNew)
		{
			m_bNew = FALSE;
			SelArray.RemoveAll();
			for( b=0; b<m; b++)
			{
				if( CompArray[b] == p)
				{
					CompArray.RemoveAt(b);
					break;
				}
			}
			delete p;
		}
		// Altrimenti va semplicemente ripristinato.
		else
		{
			LoadStates( SelArray);
			UpdateCompArray( CompArray, SelArray);
			RedrawGroup( SelArray, FALSE);
		}

	}
	else if( m_bMoving)
	{
		if( !m_bMoveFirst)
			RedrawGroup( SelArray, TRUE, FALSE);

		if( m_bJustKill)
		{
			if( m_bSecca)
			{
				int a,n=SelArray.GetSize();
				for( a=0; a<n; a++)
					delete (SelArray.GetAt(a));
				SelArray.RemoveAll();
			}
			else if( !m_bMoveFirst)
			{
				LoadStates( SelArray);
				UpdateCompArray( CompArray, SelArray);
				RedrawGroup( SelArray, FALSE);
			}
			m_bMoving = m_bJustKill = m_bMoveFirst = m_bSecca = FALSE;
			::ReleaseCapture();
		}
		else
		{
			if( m_bMoveFirst)
			{
				HideGroup( SelArray);
				m_bMoveFirst = FALSE;
			}

			RotateGroup( SelArray, point);
			if( !m_bSwap)
				m_nRotations++;
			else
				m_nRotations--;
			if( m_nRotations < 0)
				m_nRotations += 4;
			if( m_nRotations > 3)
				m_nRotations -= 4;
			RedrawGroup( SelArray, TRUE, FALSE);
		}
	}
}

void CElecDrawView::OnRButtonDown(UINT nFlags, CPoint point) 
{
	if( ((CMainFrame *)AfxGetMainWnd())->m_SelectedPrimitive == B_ZOOM)
	{
		CClientDC dc(this);
		OnPrepareDC( &dc);
		dc.DPtoLP( &point);
		SnapPoint( point);

		CPoint neworig;
		CalcNewOrigin( dc, neworig, point, GetZoom()/MAGSTEP);
		SetOrigin( neworig, FALSE);
		SetZoom( GetZoom()/MAGSTEP, FALSE, FALSE, TRUE);
	}
	else if( !m_bChanging && !m_bRectangleSel && !m_bMoving)
	{
		CPoint backup = point;

		// subset della OnLButtonDown
		PRIMARRAY& CompArray = GetDocument()->m_compArray;
		PRIMARRAY& SelArray = GetDocument()->m_selArray;
		PROXIMITY_TYPE prox;

		CClientDC dc(this);
		OnPrepareDC( &dc);
		CPoint ptRaw = point;
		dc.DPtoLP( &point);
		SnapPoint( point);

		// Scorre in rassegna tutti gli oggetti del documento (prima i selezionati,
		// poi gli altri)
		BOOL bSomethingSel=FALSE;
		CPrimitive *p, *pPrimitive = NULL;
		int a, l = CompArray.GetSize();
		for( a=0; a<l; a++)
		{
			p = CompArray[a];
			if( !p->IsSelected() || !IsComponentVisible(p))
				continue;

			bSomethingSel = TRUE;
			if( (prox = p->IsPtNear( ptRaw, &dc)) != NEAR_NONE)
			{
				pPrimitive = p;
				break;
			}
		}
		if( pPrimitive == NULL)
			for( a=0; a<l; a++)
			{
				p = CompArray[a];
				if( p->IsSelected() || !IsComponentVisible(p))
					continue;

				if( (prox = p->IsPtNear( ptRaw, &dc)) != NEAR_NONE)
				{
					pPrimitive = p;
					break;
				}
			}

		// Deseleziona tutto, se c'e' bisogno (se dopo dobbiamo ridisegnare
		// comunque, non ridisegna)
		if( (pPrimitive == NULL || !pPrimitive->IsSelected()) && bSomethingSel)
			DeselectAllObjects( CompArray, SelArray,
				(pPrimitive!=NULL && (pPrimitive->GetProp() & PROP_ERASEONSELECT)!=0) ? FALSE : TRUE);

		// Seleziona qualcosa, se c'e' bisogno
		if( pPrimitive != NULL && !pPrimitive->IsSelected())
		{
			pPrimitive->Select();
			SelArray.Add( pPrimitive);
			
			// Se la primitiva e` puzzolente, dobbiamo ridisegnare
			if( pPrimitive->GetProp() & PROP_ERASEONSELECT)
				GetDocument()->UpdateAllViews( NULL);
			else
				RedrawGroup( SelArray, FALSE);
		}

		// Visualizza il menu contestuale
		ClientToScreen( &backup);
		m_ContextMenu.GetSubMenu(0)->TrackPopupMenu( TPM_LEFTALIGN, backup.x, backup.y, AfxGetMainWnd());
	}
}

void CElecDrawView::OnLButtonUp(UINT nFlags, CPoint point) 
{
	PRIMARRAY& CompArray = GetDocument()->m_compArray;
	PRIMARRAY& SelArray = GetDocument()->m_selArray;
	BOOL bChanged = FALSE;

	CClientDC dc(this);
	OnPrepareDC( &dc);
	CPoint ptRaw = point;
	dc.DPtoLP( &point);

	// Gestisce lo snap
	SnapPoint( point);

	if( m_bDragging)
	{
		::ReleaseCapture();
		::SetCursor( m_DragOpenCursor);
		m_bDragging = FALSE;
	}
	else if( m_bRectangleSel)
	{
		m_bRectangleSel = FALSE;

		CRect rcNormalized = m_rcSel;
		rcNormalized.NormalizeRect();
		DrawSelRect( dc, rcNormalized);
		::ReleaseCapture();

		if( m_rcSel.Width() != 0 && m_rcSel.Height() != 0)
		{
			/*
				Seleziona tutti gli oggetti contenuti nel rettangolo (quelli che non
				erano gia' selezionati)
				(NB: se il rettangolo ha larghezza o altezza negativa, la selezione
				copre anche gli oggetti parzialmente inclusi; altrimenti l'oggetto
				deve essere completamente incluso)
			*/
			BOOL bErase = FALSE;
			BOOL bPartial = (m_rcSel.Width() < 0 || m_rcSel.Height() < 0) ? TRUE : FALSE;
			int a, n=CompArray.GetSize();
			CPrimitive *p;
			CRect rc;
			for( a=0; a<n; a++)
			{
				p = CompArray.GetAt(a);

				// Ignora componenti invisibili
				if( !IsComponentVisible( p))
					continue;

				if( p->GetRegion()->m_hObject == NULL)
					MessageBeep(0);
				else
				{
					p->GetRegion()->GetRgnBox( &rc);
					if( RettangoloDentro( rc, m_rcSel, bPartial) && !(p->IsSelected()))
					{
						p->Select();
						if( p->GetProp() & PROP_ERASEONSELECT)
							bErase = TRUE;
						SelArray.Add( p);
					}
				}
			}

			// Ridisegno soltanto se ho selezionato delle primitive
			// con flag PROP_ERASEONSELECT
			if( bErase)
				GetDocument()->UpdateAllViews( NULL);
			else
				RedrawGroup( SelArray, FALSE, TRUE);
		}
	}
	else if( m_bChanging)
	{
		CPrimitive *p = SelArray[0];

		// Caso particolare: stiamo definendo il secondo punto, ma il click e'
		// avvenuto sul primo punto (pensate alla situazione). In tal caso il
		// click deve essere IGNORATO
		if( m_nPointToChange == 1 && point == p->GetPoint(0))
			return;

		p->Draw( &dc, TRUE);

		// Gestisce primitive che necessitano la dialog delle proprieta`
		if( (p->GetProp() & PROP_NEEDPROPS) && m_nPointToChange == p->GetNumDefPoints()-1)
		{
			::ReleaseCapture();
			CGiveStringDialog dlg( this, &SelArray);
			if( dlg.DoModal() != IDOK)
			{
				// Se l'utente ha premuto cancel, elimino la primitiva
				SelArray.RemoveAll();
				int b,m=CompArray.GetSize();
				for( b=0; b<m; b++)
				{
					if( CompArray[b] == p)
					{
						CompArray.RemoveAt(b);
						break;
					}
				}
				delete p;
				m_bChanging = m_bMoving = m_bMoveFirst = m_bSecca = m_bNew = FALSE;
				GetDocument()->UpdateAllViews( NULL);
				return;
			}
		}

		// Se stiamo definendo un nuovo oggetto e abbiamo finito i punti di 
		// definizione (o se stavamo soltanto modificando un punto), possiamo uscire;
		// altrimenti passiamo al prossimo punto.
		// La funzione permette l'IMPOSTAZIONE DINAMICA da parte delle primitive:
		// la primitiva "fa in tempo" a restituire un numero piu' alto in
		// GetNumDefPoints, se l'assegnazione dell'ultimo punto e' stata
		// appropriata. Questo e' utile per primitive con un numero variabile di
		// punti.
		m_nPointToChange++;
		if( m_nPointToChange <= p->GetNumDefPoints())
			p->SetPoint( m_nPointToChange-1, point, TRUE);

		if( m_nPointToChange >= p->GetNumDefPoints() || !m_bNew)
		{
			::ReleaseCapture();
			m_bChanging = m_bMoving = FALSE;	// m_bNew e' piu' sotto

			if( !(p->IsProper()))
			{
				SelArray.RemoveAll();
				delete p;
				m_bNew = FALSE;
			}
			else
			{
				if( m_bNew || m_ClickPoint != point || m_nRotations % 4 != 0 ||
					m_bSwap || p->GetNumDefPoints() == 1)
				{
					bChanged = TRUE;
					GetDocument()->SetModifiedFlag();
				}
				GetDocument()->UpdateBoundingRegions( &dc, SelArray);
				UpdateCompArray( CompArray, SelArray);

				// Se il componente e` di tipo serial e nuovo,
				// "simula" una nuova pressione
				if( (p->GetProp() & PROP_SERIALCREATE) && m_bNew)
				{
					m_bNew = FALSE;
					p->Select( FALSE);
					SelArray.RemoveAll();
					COLORREF clr = ((CMainFrame *)AfxGetMainWnd())->m_layerColors[p->GetLayer()];
					p->Draw( &dc, FALSE, RGB(255,255,255), clr);
					OnLButtonDown( nFlags, ptRaw);
					OnLButtonUp( nFlags, ptRaw);
				}
				else
				{
					m_bNew = FALSE;
					RedrawGroup( SelArray, FALSE);
				}
			}
		}
		else
		{
			p->SetPoint( m_nPointToChange, point);
			p->Draw( &dc, TRUE);
		}
	}
	else if( m_bMoving)
	{
		::ReleaseCapture();

		if( m_ClickPoint != point || m_nRotations % 4 != 0 || m_bSwap)
		{
			bChanged = TRUE;
			GetDocument()->SetModifiedFlag();
		}

		if( !m_bMoveFirst)
		{
			RedrawGroup( SelArray, TRUE, FALSE);
			GetDocument()->UpdateBoundingRegions( &dc, SelArray);
			UpdateCompArray( CompArray, SelArray);
			RedrawGroup( SelArray, FALSE);
		}
		m_bChanging = m_bMoving = m_bMoveFirst = m_bSecca = FALSE;
	}

	// Se necessario, inserisce lo step nell'undo buffer
	if( bChanged)
		GetDocument()->UndoStore();
}

void CElecDrawView::OnLButtonDblClk(UINT nFlags, CPoint point) 
{
	// Invoca le proprieta' solo con il tool di selezione
	if( ((CMainFrame *)AfxGetMainWnd())->m_SelectedPrimitive == B_NONE)
		OnEditProperties();	
}


void CElecDrawView::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	switch( nChar)
	{
		case VK_ESCAPE:
			if( m_bMoving || m_bChanging || m_bRectangleSel)
			{
				m_bJustKill = TRUE;
				OnRButtonUp( 0, m_OldPoint);
				::ReleaseCapture();
			}
			else
			{
				// Toggle fra selezione e ultima primitiva
				CMainFrame *wnd = (CMainFrame *)AfxGetMainWnd();
				if( wnd->m_SelectedPrimitive == B_NONE)
				{
					if( wnd->m_OldPrimitive != wnd->m_SelectedPrimitive)
					{
						wnd->m_SelectedPrimitive = wnd->m_OldPrimitive;
						if( wnd->m_OldPrimitive == B_ZOOM)
							::SetCursor( m_LensCursor);
						else
							::SetCursor( m_CrossCursor);
					}
				}
				else
				{
					wnd->m_SelectedPrimitive = B_NONE;
					::SetCursor( m_NormCursor);
				}				
			}
			break;

		case VK_DELETE:		// Lo faccio a mano per non collidere con la edit del titolo
			::ReleaseCapture();
			OnEditClear();
			break;

		case 's':
		case 'S':
			if( m_bMoving)
			{
				PRIMARRAY& SelArray = GetDocument()->m_selArray;

				if( !m_bMoveFirst)
					RedrawGroup( SelArray, TRUE, FALSE);
				else
				{
					HideGroup( SelArray);
					m_bMoveFirst = FALSE;
				}

				SwapGroup( SelArray, m_OldPoint.x);

				if( m_bSwap)
					m_bSwap = FALSE;
				else
					m_bSwap = TRUE;

				RedrawGroup( SelArray, TRUE, FALSE);
			}
			else if( m_bChanging)
			{
				PRIMARRAY& SelArray = GetDocument()->m_selArray;
				CPrimitive *p = SelArray[0];
				CClientDC dc(this);
				OnPrepareDC( &dc);

				// Se l'oggetto e' swappabile e necessita di un solo punto, lo swappo
				if( (p->GetProp() & (PROP_SWAPFULL | PROP_SWAPHALF)) && 
					(p->GetNumDefPoints() == 1))
				{
					p->Draw( &dc, TRUE);
					SwapGroup( SelArray, m_OldPoint.x);
					
					if( m_bSwap)
						m_bSwap = FALSE;
					else
						m_bSwap = TRUE;
					
					p->Draw( &dc, TRUE);
				}
			}
			else
				OnEditSwap();
			break;

		case 'r':
		case 'R':
			if( m_bMoving || m_bChanging || m_bRectangleSel)
				OnRButtonUp( 0, m_OldRawPoint);
			else
				OnEditRotate();
			break;
	}

	CView::OnKeyDown(nChar, nRepCnt, nFlags);
}

void CElecDrawView::OnEditProperties() 
{
	PRIMARRAY& SelArray = GetDocument()->m_selArray;
	int a, n = SelArray.GetSize();
	SetFocus();

	// mostra proprieta'
	if( n >= 1)
	{
		CGiveStringDialog dlg( this, &SelArray);
		if( dlg.DoModal() == IDOK)
		{
			// Tolgo dal SelArray tutti i componenti che sono diventati invisibili
			CPrimitive *p;
			for( a=n-1; a>=0; a--)
			{
				p = SelArray.GetAt(a);
				if( !IsComponentVisible(p))
				{
					p->Select( FALSE);
					SelArray.RemoveAt(a);
				}
			}

			GetDocument()->SetModifiedFlag();
			CClientDC dc(this);
			OnPrepareDC( &dc);
			GetDocument()->UpdateBoundingRegions( &dc, SelArray);
			GetDocument()->UpdateAllViews( NULL);

			// Inserisce lo step nell'undo buffer
			GetDocument()->UndoStore();
		}
	}
}

void CElecDrawView::OnUpdateEditProperties(CCmdUI* pCmdUI) 
{
	PRIMARRAY& SelArray = GetDocument()->m_selArray;
	
	if( SelArray.GetSize() >= 1)
		pCmdUI->Enable( TRUE);
	else
		pCmdUI->Enable( FALSE);
}


/*
	DeselectAllObjects
	Funzione autoesplicativa.
*/

void CElecDrawView::DeselectAllObjects( PRIMARRAY& CompArray,
		PRIMARRAY& SelArray, BOOL bRepaint)
{
	CPrimitive *pPrim;
	int b, m = CompArray.GetSize();
	CWaitCursor pippo;
	BOOL bChanged = FALSE;

	SelArray.RemoveAll();


	for( b=0; b<m; b++)
	{
		pPrim = CompArray[b];
		if( pPrim->IsSelected())
		{
			pPrim->Select( FALSE);
			bChanged = TRUE;
		}
	}

	if( bRepaint && bChanged)
		GetDocument()->UpdateAllViews( NULL);
}


void CElecDrawView::SaveStates( PRIMARRAY& SelArray)
{
	int a, n=SelArray.GetSize();

	for( a=0; a<n; a++)
		SelArray[a]->SaveState();
}


void CElecDrawView::LoadStates( PRIMARRAY& SelArray)
{
	int a, n=SelArray.GetSize();

	for( a=0; a<n; a++)
		SelArray[a]->LoadState();
}


void CElecDrawView::HideGroup( PRIMARRAY& SelArray)
{
	PRIMARRAY* CompArray = &(((CElecDrawDoc *)GetDocument())->m_compArray);
	int a, b, n=SelArray.GetSize(), m=CompArray->GetSize();
	PRIMARRAY TempComp, TempSel;
	CObject *p;
	CWaitCursor pippo;

	// Backup di CompArray e SelArray
	for( a=0; a<m; a++)
		TempComp.SetAtGrow( a, CompArray->GetAt(a));
	for( a=0; a<n; a++)
		TempSel.SetAtGrow( a, SelArray.GetAt(a));

	// Cancello da CompArray gli elementi in SelArray
	for( a=0; a<n; a++)
	{
		p = SelArray[a];
		for( b=0; b<m; b++)
		{
			if( CompArray->GetAt(b) == p)
			{
				CompArray->RemoveAt( b);
				b--; m--;
			}
		}
	}

	// Refresh dello schermo
	GetDocument()->UpdateAllViews( NULL);
}


void CElecDrawView::RedrawGroup( PRIMARRAY& SelArray, BOOL bXNOR, BOOL bDefPoints)
{
	int a, b, n=SelArray.GetSize();
	CPrimitive *p;

	if( n==0)
		return;			// non dovrebbe mai succedere, ma non si sa mai

	CClientDC dc(this);
	OnPrepareDC( &dc);

	CRect rc;
	GetClientRect( &rc);
	dc.DPtoLP( &rc);

	/*
		A questo punto mi e' venuta un'idea: perche' stare a ruotare e swappare i 
		bounding rectangles di ciascuna primitiva (o, ancora peggio, ricalcolare
		completamente le bounding regions) quando possiamo ruotare e swappare una
		volta sola (pero' al contrario) il RETTANGOLO VISIBILE dell'area di lavoro?
		Quello che faccio cioe' e' fare finta che non siano gli oggetti a 
		muoversi/ruotare/swappare "in un verso", ma la client "nel verso opposto".

		Per mettere in pratica il mio piano devo disporre di alcune informazioni:

		-Il punto di cliccaggio del cursore (m_ClickPoint);
		-Il punto attuale del cursore (m_ActualPoint);
		-Il punto precedente del cursore (m_OldPoint);
		-Eventuali rotazioni compiute dall'inizio del trascinamento (m_nRotations);
		-Eventuale swap su un asse verticale (m_bSwap).

		Questi dati li ho resi disponibili sotto forma di variabili membro... non e'
		una mossa molto pulita, ma mi semplifica UN TOTALE la vita.

		Nota: la tecnica la metto in pratica soltanto se sto XOR-ando (cioe' se sono
		nella fase intermedia di uno spostamento/rotazione). Prima del disegno
		definitivo (cioe' la chiamata di questa funzione, ma senza XOR) e' necessario 
		che le bounding regions siano gia' state aggiornate; questo non e' oneroso,
		visto che e' fatto una volta sola e che deve essere fatto comunque.

		Altra nota: queste tecniche non sono valide ne' per gli oggetti non- o
		semi-rotanti nel caso che l'angolo di rotazione non sia un multiplo di 360, ne'
		per gli oggetti non- o semi-swappabili nel caso che sia stato eseguito uno swap
		(visto che le nuove posizioni delle bounding regions non sono prevedibili a
		priori). In questi ultimi casi, nel dubbio, disegnamo sempre gli oggetti.
	*/
	if( bXNOR)
	{
		// calcolo i rettangoli traslati, attuale e precedente, poi li unisco
		CRect rcAct = rc + CPoint( m_ClickPoint.x-m_ActualPoint.x, m_ClickPoint.y-m_ActualPoint.y);
		CRect rcOld = rc + CPoint( m_ClickPoint.x-m_OldPoint.x, m_ClickPoint.y-m_OldPoint.y);
		rcAct.InflateRect( 1, 1);
		rcOld.InflateRect( 1, 1);
		rc.UnionRect( &rcAct, &rcOld);

		// Ruoto rc attorno a m_ClickPoint per m_nRotations volte,
		// in senso antiorario nel caso di
		CPoint pt[4], ptTmp;
		pt[0] = CPoint( rc.left, rc.top);
		pt[1] = CPoint( rc.right, rc.top);
		pt[2] = CPoint( rc.left, rc.bottom);
		pt[3] = CPoint( rc.right, rc.bottom);
		for( b=0; b<m_nRotations; b++)
		{
			for( a=0; a<4; a++)
			{	
				ptTmp = pt[a];
				pt[a].x = m_ClickPoint.x + (ptTmp.y-m_ClickPoint.y);
				pt[a].y = m_ClickPoint.y - (ptTmp.x-m_ClickPoint.x);
			}
		}

		// Lo swappo pure, se ce n'e' bisogno
		// (su asse verticale per rotazioni pari, su asse orizzontale per
		// rotazioni dispari).
		if( m_bSwap)
		{
			for( a=0; a<4; a++)
			{
				ptTmp = pt[a];
				if( m_nRotations % 2)
					pt[a].y = 2*m_ClickPoint.y - ptTmp.y;
				else
					pt[a].x = 2*m_ClickPoint.x - ptTmp.x;
			}
		}
		
		// Ricostruisco il rettangolo e lo normalizzo
		for( a=1; a<4; a++)
			if( pt[a].x != pt[0].x && pt[a].y != pt[0].y)
				break;
		CRect rc1( pt[0], pt[a]);
		rc1.NormalizeRect();
		rc.CopyRect( &rc1);
	}

	// Ora posso usare rc in modo esatto
	CRect rcp;
	for( a=0; a<n; a++)
	{
		p = SelArray[a];

		/*	L'ottimizzazione di disegno e' completa solo per oggetti rotanti; per 
			oggetti non rotanti e semirotanti, l'ottimizzazione ha luogo soltanto se
			non sono avvenute rotazioni (o comunque se ce n'e' stato un multiplo di 4).
			Stesso discorso per quanto riguarda lo swap.
		*/

		if( (p->GetRegion()->m_hObject != NULL) &&
			((m_nRotations % 4 == 0)	|| (p->GetProp() & PROP_ROTATEFULL)) &&
			((!m_bSwap)					|| (p->GetProp() & PROP_SWAPFULL)))
				p->GetRegion()->GetRgnBox( &rcp);
		else
				rcp.CopyRect( &rc);		// Ridisegno sicuramente :-)

		if( RettangoloDentro( rcp, rc, TRUE))
			p->Draw( &dc, bXNOR);
	}

	if( bDefPoints)
		DrawDefPoints( &dc, SelArray);
}


void CElecDrawView::RotateGroup( PRIMARRAY& SelArray, CPoint pt)
{
	int a, n=SelArray.GetSize();
	CPrimitive *pPrimitive;
	CWaitCursor pippo;

	for( a=0; a<n; a++)
	{
		pPrimitive = SelArray.GetAt(a);
		if( !(pPrimitive->GetProp() & (PROP_ROTATEFULL | PROP_ROTATEHALF)))
			continue;
		
		pPrimitive->Rotate( pt);
	}
}

void CElecDrawView::SwapGroup( PRIMARRAY& SelArray, int xPos)
{
	int a, n=SelArray.GetSize();
	CPrimitive *pPrimitive;
	CWaitCursor pippo;

	for( a=0; a<n; a++)
	{
		pPrimitive = SelArray.GetAt(a);
		if( !(pPrimitive->GetProp() & (PROP_SWAPFULL | PROP_SWAPHALF)))
			continue;
		
		pPrimitive->Swap( xPos);
	}
}

BOOL CElecDrawView::SnapPoint( CPoint& point)
{
	static CPoint oldpt = CPoint( -1, -1);
	CPoint ptsnapped;
	int xs = ABS(point.x) % m_GridDlg.m_xsnap;
	int ys = ABS(point.y) % m_GridDlg.m_ysnap;
	if( point.x < 0) xs *= -1;
	if( point.y < 0) ys *= -1;

//	TODO: cazzo e`?
//	if( ys < 0)
//		Sleep(1);

	if( m_GridDlg.m_bSnapEnable)
	{
		if( m_GridDlg.m_xsnap > 1)
		{
			if( ABS(xs) < (int)m_GridDlg.m_xsnap/2)
				ptsnapped.x = point.x - xs;
			else if( xs > 0) 
				ptsnapped.x = point.x + m_GridDlg.m_xsnap - xs;
			else
				ptsnapped.x = point.x - m_GridDlg.m_xsnap - xs;
		}
		else
			ptsnapped.x = point.x;

		if( m_GridDlg.m_ysnap > 1)
		{
			if( ABS(ys) < (int)m_GridDlg.m_ysnap/2)
				ptsnapped.y = point.y - ys;
			else if( ys > 0)
				ptsnapped.y = point.y + m_GridDlg.m_ysnap - ys;
			else
				ptsnapped.y = point.y - m_GridDlg.m_ysnap - ys;
		}
		else
			ptsnapped.y = point.y;

		point = ptsnapped;

		if( oldpt == ptsnapped)
			return FALSE;

		oldpt = ptsnapped;
	}

	return TRUE;
}


/*
	RettangoloDentro
	Restituisce TRUE se il rettangolo 'tryrect' e' dentro al rettangolo 'target'.
	Se bPartial==FALSE, tutto il rettangolo deve essere contenuto; altrimenti
	basta che ne sia contenuta una parte (ossia che l'intersezione fra i due non
	sia nulla).
*/

BOOL CElecDrawView::RettangoloDentro( CRect tryrect, CRect target, BOOL bPartial)
{
	tryrect.NormalizeRect();
	target.NormalizeRect();

	if( !bPartial)
	{
		if( tryrect.top >= target.top && tryrect.bottom <= target.bottom &&
			tryrect.left >= target.left && tryrect.right <= target.right)
				return TRUE;
		else
				return FALSE;
	}
	else
	{
		if( tryrect.bottom < target.top ||
			tryrect.top > target.bottom ||
			tryrect.right < target.left ||
			tryrect.left > target.right)
				return FALSE;
		else
				return TRUE;
	}
}


/*
	DrawDefPoints
	Disegna i punti definenti
*/

void CElecDrawView::DrawDefPoints( CDC *pDC, PRIMARRAY& CompArray)
{
	CBrush brush( RGB( 128, 128, 255));
	int a, n=CompArray.GetSize();
	CPrimitive *pPrimitive;
	int b,m;
	
	CRect rcVisible;
	GetClientRect( &rcVisible);
	pDC->DPtoLP( &rcVisible);
	rcVisible.InflateRect( 1, 1);
	
	// Mappa e memorizza tutti i punti visibili
	CArray< CPoint, CPoint> pts;
	CPoint pt;
	CPoint ptMacroOrig( XMACRO_ORIG, YMACRO_ORIG);
	pDC->LPtoDP( &ptMacroOrig);
	for( a=0; a<n; a++)
	{
		pPrimitive = CompArray.GetAt(a);

		// Ignora componenti costanti, non selezionati o nascosti
		if( pPrimitive->IsConst() || !(pPrimitive->IsSelected()) || !IsComponentVisible( pPrimitive))
			continue;

		m = pPrimitive->GetNumDefPoints();
		for( b=0; b<m; b++)
		{
			pt = pPrimitive->GetPoint(b);
			if( rcVisible.PtInRect( pt))
			{
				pDC->LPtoDP( &pt);
				pts.Add( pt);
			}
		}
	}

	// Memorizza le informazioni sul mapping mode, ecc
	int nOld = pDC->GetMapMode();
	CPoint ptOld = pDC->GetViewportOrg();
	CSize siOldv = pDC->GetViewportExt();
	CSize siOldw = pDC->GetWindowExt();

	// Torniamo al mapping tradizionale
	pDC->SetMapMode( MM_TEXT);
	pDC->SetViewportOrg( 0, 0);

	// Disegnamo i quadretti!
	n = pts.GetSize();
	for( a=0; a<n; a++)
	{
		pDC->FillRect( CRect(	pts[a].x-SELECTOR_SIZE/2,
								pts[a].y-SELECTOR_SIZE/2,
								pts[a].x+SELECTOR_SIZE/2,
								pts[a].y+SELECTOR_SIZE/2),
								&brush);
	}
	brush.DeleteObject();

	// Evidenziamo il punto di origine delle macro
	if( !(m_GridDlg.m_bHideMacroOrigin))
	{
		CBrush brush( RGB( 255,0,0)), *oldbrush;
		oldbrush = pDC->SelectObject( &brush);
		pDC->Ellipse( ptMacroOrig.x-SELECTOR_SIZE/2, ptMacroOrig.y-SELECTOR_SIZE/2,
			ptMacroOrig.x+SELECTOR_SIZE/2, ptMacroOrig.y+SELECTOR_SIZE/2);
		pDC->SelectObject( oldbrush);
		brush.DeleteObject();
	}

	// Rimettiamo a posto il mapping mode
	pDC->SetMapMode( nOld);
	pDC->SetWindowExt( siOldw);
	pDC->SetViewportExt( siOldv);
	pDC->SetViewportOrg( ptOld);
}

BOOL CElecDrawView::OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message) 
{
	if( nHitTest == HTCLIENT)
	{
		switch( ((CMainFrame *)AfxGetMainWnd())->m_SelectedPrimitive)
		{
			case B_NONE:
				//::SetCursor( m_NormCursor);
				break;

			case B_ZOOM:
				::SetCursor( m_LensCursor);
				break;

			case B_DRAG:
				if( m_bDragging)
					::SetCursor( m_DragClosedCursor);
				else
					::SetCursor( m_DragOpenCursor);
				break;

			default:
				::SetCursor( m_CrossCursor);
		}
		return TRUE;
	}
	
	return CView::OnSetCursor(pWnd, nHitTest, message);
}

void CElecDrawView::CalcNewOrigin( CDC& dc, CPoint& origin, CPoint point, double newzoom)
{
	// Devo fare in modo che il punto in cui si e' cliccato rimanga nell'area
	// e che sia il piu' vicino possibile alla posizione del cursore,
	// anche dopo lo zoom
	CRect rc;
	GetClientRect( &rc);

	// Dimensione della client dopo lo zoom...
	double cx = rc.Width() / newzoom, cy = rc.Height() / newzoom;
	if( cx > DEFAULT_AREAX)
		cx = DEFAULT_AREAX;
	if( cy > DEFAULT_AREAY)
		cy = DEFAULT_AREAY;

	// Origine stimata!
	int ox = (int)(point.x - cx/2), oy = (int)(point.y - cy/2);
	if( ox < 0)
		ox = 0;
	else if( ox > DEFAULT_AREAX-cx)
		ox = (int)(DEFAULT_AREAX-cx);
	if( oy < 0)
		oy = 0;
	else if( oy > DEFAULT_AREAY-cy)
		oy = (int)(DEFAULT_AREAY-cy);

	origin = CPoint( ox, oy);
}

void CElecDrawView::DrawSelRect( CDC& dc, CRect& rc)
{
	dc.DrawFocusRect( rc);
}


BOOL CElecDrawView::IsFitting()
{
	return FALSE;
}

void CElecDrawView::FoolSize()
{
	OnSize(0,0,0);
}

/* Helper che guarda se un componente e` su un layer video nascosto */
BOOL CElecDrawView::IsComponentVisible( CPrimitive *p)
{
	if( p == NULL)
		return FALSE;

	int idx = p->GetLayer();
	return ((CMainFrame*)AfxGetMainWnd())->m_bLayerShow[idx];
}
