// ElecDrawView.h : interface of the CElecDrawView class
//
/////////////////////////////////////////////////////////////////////////////

class CElecDrawView : public CView
{
protected:
	CElecDrawView();
	DECLARE_DYNCREATE(CElecDrawView)

	CPoint				m_ClickPoint;
	CPoint				m_ActualPoint;
	CPoint				m_OldPoint;
	CPoint				m_OldRawPoint;
	CPoint				m_ClickOrigin;
	int					m_nRotations;
	BOOL				m_bSwap;

	CRect				m_rcSel;
	BOOL				m_bRectangleSel;
	BOOL				m_bChanging;
	BOOL				m_bMoving;
	BOOL				m_bDragging;
	BOOL				m_bNew;
	BOOL				m_bJustKill;
	BOOL				m_bMoveFirst;
	BOOL				m_bSecca;
	BOOL				m_bTimer;
	int					m_nTimerTicks;
	int					m_nPointToChange;
	int					m_BorderProximity;
	BOOL				m_PCBmode;

	// Sync stuff
	BOOL				m_bScrollRedraw;

	// Simulazione di CScrollView
	CPoint				m_Origin;			// Origine del viewpoint (logical unitz)
	BOOL				m_bStretch;			// Autostretch
	//BOOL				m_bFit;				// Autofit
	double				m_ZoomFact;			// Zoom factor
	double				m_ScaleX, m_ScaleY;	// Scale dell'autostretch

	// Varie und efentuali
	HCURSOR				m_NormCursor;
	HCURSOR				m_LensCursor;
	HCURSOR				m_CrossCursor;
	HCURSOR				m_SizeCursor;
	HCURSOR				m_MoveCursor;
	HCURSOR				m_DragClosedCursor;
	HCURSOR				m_DragOpenCursor;

	CMenu				m_ContextMenu;



	
	
	void DeselectAllObjects( PRIMARRAY& CompAr, PRIMARRAY& SelAr, BOOL bRepaint=TRUE);
	void SaveStates( PRIMARRAY& SelArray);
	void LoadStates( PRIMARRAY& SelArray);
	void HideGroup( PRIMARRAY& SelArray);
	void RedrawGroup( PRIMARRAY& SelArray, BOOL bXNOR, BOOL bDefPoints=TRUE);
	void RotateGroup( PRIMARRAY& SelArray, CPoint pt);
	void SwapGroup( PRIMARRAY& SelArray, int xPos);
	BOOL SnapPoint( CPoint& pt);
	void SetScrollBars( void);
	void DrawDefPoints( CDC *pDC, PRIMARRAY& CompArray);
	BOOL RettangoloDentro( CRect tryrect, CRect target, BOOL bPartial = FALSE);
	void UpdateSelArray( PRIMARRAY& CompArray, PRIMARRAY& SelArray);
	void UpdateCompArray( PRIMARRAY& CompArray, PRIMARRAY& SelArray);
	void CalcNewOrigin( CDC& dc, CPoint& origin, CPoint point, double newzoom);
	void DrawSelRect( CDC& dc, CRect& rc);
	CPoint FindMiddlePoint( PRIMARRAY& SelArray);

public:
	CElecDrawDoc*		GetDocument();
	CGridDialog			m_GridDlg;

	void SetOrigin( CPoint ptOrigin, BOOL bRedraw);
	CPoint GetOrigin( void);
	void SetZoom( double factor, BOOL bStretch, BOOL bFit, BOOL bRedraw);
	double GetZoom( void);
	BOOL IsFitting();
	void FoolSize();

	static BOOL IsComponentVisible( CPrimitive *p);

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CElecDrawView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual void OnInitialUpdate();
	virtual void OnPrepareDC(CDC* pDC, CPrintInfo* pInfo = NULL);
	protected:
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CElecDrawView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
public:
	//{{AFX_MSG(CElecDrawView)
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnRButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnEditProperties();
	afx_msg void OnUpdateEditProperties(CCmdUI* pCmdUI);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnUpdateEditCopy(CCmdUI* pCmdUI);
	afx_msg void OnEditCut();
	afx_msg void OnEditPaste();
	afx_msg void OnUpdateEditPaste(CCmdUI* pCmdUI);
	afx_msg void OnEditCopy();
	afx_msg void OnUpdateEditCut(CCmdUI* pCmdUI);
	afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg BOOL OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message);
	afx_msg void OnEditClear();
	afx_msg void OnUpdateEditClear(CCmdUI* pCmdUI);
	afx_msg void OnEditSplitmacro();
	afx_msg void OnUpdateEditSplitmacro(CCmdUI* pCmdUI);
	afx_msg void OnEditInvert();
	afx_msg void OnViewStretch();
	afx_msg void OnViewGrid();
	afx_msg void OnUpdateViewStretch(CCmdUI* pCmdUI);
	afx_msg void OnEditSelectAll();
	afx_msg void OnLButtonDblClk(UINT nFlags, CPoint point);
	afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnEditCreamacro();
	afx_msg void OnUpdateEditCreamacro(CCmdUI* pCmdUI);
	afx_msg void OnEditRotate();
	afx_msg void OnUpdateEditRotate(CCmdUI* pCmdUI);
	afx_msg void OnEditSwap();
	afx_msg void OnUpdateEditSwap(CCmdUI* pCmdUI);
	afx_msg void OnComboZoomEditChange();
	afx_msg void OnComboZoomSelChange();
	afx_msg void OnButtonGotoorigin();
	afx_msg void OnViewRefresh();
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	afx_msg void OnButtonSnap();
	afx_msg void OnUpdateButtonSnap(CCmdUI* pCmdUI);
	afx_msg void OnButtonPcbmode();
	afx_msg void OnUpdateButtonPcbmode(CCmdUI* pCmdUI);
	afx_msg void OnViewFit();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in ElecDrawView.cpp
inline CElecDrawDoc* CElecDrawView::GetDocument()
   { return (CElecDrawDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////
