// GiveStringDialog.cpp : implementation file
//

#include "stdafx.h"
//#include "DlgSplash.h"
#include "ElecDraw.h"
#include "Primitive.h"
#include "LayerComboBox.h"
#include "GiveStringDialog.h"
#include "DlgMacroBar.h"
#include "ConfigDialog.h"
#include "GridDialog.h"
#include "ViewToolbar.h"
#include "ElecDrawDoc.h"
#include "ElecDrawView.h"
#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CGiveStringDialog dialog


CGiveStringDialog::CGiveStringDialog(CWnd* pParent, PRIMARRAY* SelArray)
	: CDialog(CGiveStringDialog::IDD, pParent)
{
	m_SelArray = SelArray;
}

BEGIN_MESSAGE_MAP(CGiveStringDialog, CDialog)
	//{{AFX_MSG_MAP(CGiveStringDialog)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CGiveStringDialog message handlers

/*
	La dialog delle proprieta` mostra tutti e solo gli attributi in comune degli
	oggetti selezionati. Per costruire i controlli necessari si procede cosi`:

	-Si prende il primo oggetto selezionato, si guardano tutti i suoi attributi
	alla ricerca di quelli che possiedono anche tutti gli altri oggetti
	selezionati (ovviamente se c'e` un solo oggetto, tutti gli attributi
	saranno mostrati);

	-Per ogni attributo in comune, si guarda di che tipo e`. Se e` un numero o
	una stringa, si crea una editbox; se e` una lista di stringhe, si crea
	una combo box (un po' come le proprieta` del VB). Per i layer serve una
	combo owner-draw che mostri anche il colore e il nome del layer.

	-Per ogni attributo in comune, si guarda se il valore di tale attributo e`
	uguale per ogni oggetto. Se lo e`, si imposta il controllo a tale valore;
	altrimenti lo si lascia al valore indeterminato (ovviamente se c'e` un solo
	oggetto, tutti i controlli saranno inizializzati).
*/

BOOL CGiveStringDialog::OnInitDialog() 
{
	CDialog::OnInitDialog();

	// Legge i dati dimensionali utili dai controlli invisibili presenti nella dialog
	CRect rclabel, rcedit, rccombo;
	GetDlgItem( IDC_SAMPLE_TEXT)->GetWindowRect( rclabel);
	GetDlgItem( IDC_SAMPLE_EDIT)->GetWindowRect( rcedit);
	GetDlgItem( IDC_SAMPLE_COMBO)->GetWindowRect( rccombo);
	ScreenToClient( rclabel);
	ScreenToClient( rcedit);
	ScreenToClient( rccombo);

	int a=0, b, n=m_SelArray->GetSize();
	CString name, values, value, commonval;
	BOOL bCommonval;
	CPrimitive *first = m_SelArray->GetAt(0), *next;
	UINT startID = 2000;
	HWND wnd, control;
	HFONT font;

	// Scorre tutti gli attributi della prima primitiva selezionata
	while( first->GetAttribName( a, name, values))
	{
		bCommonval = TRUE;
		first->GetAttrib( name, commonval);

		// Guarda se questo attributo e` presente anche in tutte le altre primitive
		for( b=1; b<n; b++)
		{
			next = m_SelArray->GetAt( b); 
			if( !(next->GetAttrib( name, value)))
				break;
			if( value != commonval)
				bCommonval = FALSE;
		}

		// Attributo in comune? Lo metto!
		// (nota: uso le API perche` usando MFC ottengo strani errori, penso che il framework
		// non si aspetti che qualcuno gli crei dei controlli in WM_INITDIALOG)
		if( b==n)
		{
			// La stringa e` uguale per tutti i tipi di attributo
			wnd = CreateWindowEx( 0, "STATIC", name, WS_GROUP | WS_VISIBLE | WS_CHILD, rclabel.left,
				rclabel.top + (rccombo.top-rclabel.top)*a, rclabel.Width(), rclabel.Height(),
				m_hWnd, (HMENU)startID++, ::AfxGetInstanceHandle(), NULL);
			control = GetDlgItem( IDC_SAMPLE_TEXT)->m_hWnd;
			font = (HFONT)::SendMessage( control, WM_GETFONT, 0, 0);
			::SendMessage( wnd, WM_SETFONT, (WPARAM)font, 0);

			// Il campo di inserimento invece cambia
			if( values.Left( 7) == "#STRING" ||
				values.Left( 4) == "#INT")
			{
				wnd = CreateWindowEx( WS_EX_CLIENTEDGE, "EDIT", bCommonval ? commonval : "",
					WS_TABSTOP | WS_VISIBLE | WS_CHILD | ES_AUTOHSCROLL, rcedit.left,
					rclabel.top + (rccombo.top-rclabel.top)*a, rcedit.Width(), rcedit.Height(),
					m_hWnd, (HMENU)startID++, ::AfxGetInstanceHandle(), NULL);
				control = GetDlgItem( IDC_SAMPLE_TEXT)->m_hWnd;
				font = (HFONT)::SendMessage( control, WM_GETFONT, 0, 0);
				::SendMessage( wnd, WM_SETFONT, (WPARAM)font, 0);

				// Per gli integer settiamo anche lo spin control
				if( values.Left( 4) == "#INT")
				{
					int min, max;
					sscanf( values.Mid(4), "%d %d", &min, &max);
					HWND wnd1 = ::CreateUpDownControl( WS_CHILD | WS_BORDER | WS_VISIBLE |
						UDS_ALIGNRIGHT | UDS_ARROWKEYS | UDS_AUTOBUDDY | UDS_SETBUDDYINT,
						0, 0, 1, 1, m_hWnd, startID-1, ::AfxGetInstanceHandle(), wnd, max,
						min, atoi(commonval));

					// Se non c'e` valore comune, dobbiamo rimuovere il numero che
					// lo spin control ha inserito automagicamente
					if( !bCommonval)
						::SetWindowText( wnd, "");
				}

				// Se il primo controllo e` una editbox, seleziona il testo
				if( a==0)
					::SendMessage( wnd, EM_SETSEL, 0, (LPARAM)(-1));
			}
			else
			{
				wnd = CreateWindowEx( WS_EX_CLIENTEDGE, "COMBOBOX", "", CBS_DROPDOWNLIST | CBS_SORT |
					WS_VISIBLE | WS_VSCROLL | WS_TABSTOP | WS_CHILD, rcedit.left,
					rclabel.top + (rccombo.top-rclabel.top)*a, rccombo.Width(), rccombo.Height()*5,
					m_hWnd, (HMENU)startID++, ::AfxGetInstanceHandle(), NULL);
				control = GetDlgItem( IDC_SAMPLE_TEXT)->m_hWnd;
				font = (HFONT)::SendMessage( control, WM_GETFONT, 0, 0);
				::SendMessage( wnd, WM_SETFONT, (WPARAM)font, 0);

				// Imposta i valori possibili nella combo
				::SendMessage( wnd, CB_ADDSTRING, 0, (LPARAM)"(indeterminato)");
				values = values.Mid( 1, values.GetLength()-2);
				values.TrimLeft(); values.TrimRight();
				int start = 0, idx = 0;
				do
				{
					idx = values.Mid(start).Find( " ");
					if( idx==-1)
						idx = values.GetLength();
					else
						idx += start;

					if( start < idx)
					{
						CString substr = values.Mid( start, idx-start);
						substr.TrimLeft(); substr.TrimRight();
						CPrimitive::Rimpiazza( substr, "++", " ");
						::SendMessage( wnd, CB_ADDSTRING, 0, (LPARAM)(LPCTSTR)substr);
					}

					start = idx+1;
				}while( start < values.GetLength());

				// Imposta il valore attuale
				::SendMessage( wnd, CB_SELECTSTRING, (WPARAM)(-1),
					bCommonval ? (LPARAM)(LPCTSTR)commonval : (LPARAM)"(indeterminato)");
			}
		}

		a++;
	}

	// In fondo aggiungo la combo del layer (duplico un po' di codice, ma
	// tanto la RAM costa poco)
	bCommonval = TRUE;
	int nLayer = first->GetLayer();
	for( b=1; b<n; b++)
	{
		next = m_SelArray->GetAt( b); 
		if( next->GetLayer() != nLayer)
		{
			bCommonval = FALSE;
			break;
		}
	}

	// Stringa "layer"
	wnd = CreateWindowEx( 0, "STATIC", "Layer", WS_GROUP | WS_VISIBLE | WS_CHILD, rclabel.left,
		rclabel.top + (rccombo.top-rclabel.top)*a, rclabel.Width(), rclabel.Height(),
		m_hWnd, (HMENU)startID++, ::AfxGetInstanceHandle(), NULL);
	control = GetDlgItem( IDC_SAMPLE_TEXT)->m_hWnd;
	font = (HFONT)::SendMessage( control, WM_GETFONT, 0, 0);
	::SendMessage( wnd, WM_SETFONT, (WPARAM)font, 0);

	// Combo layer
	wnd = CreateWindowEx( WS_EX_CLIENTEDGE, "COMBOBOX", "", CBS_DROPDOWNLIST | CBS_OWNERDRAWFIXED |
		CBS_HASSTRINGS | WS_VISIBLE | WS_VSCROLL | WS_TABSTOP | WS_CHILD, rcedit.left,
		rclabel.top + (rccombo.top-rclabel.top)*a, rccombo.Width(), rccombo.Height()*5,
		m_hWnd, (HMENU)startID++, ::AfxGetInstanceHandle(), NULL);

	// Aggancio la finestra all'oggetto derivato da CComboBox, dicendogli anche
	// che font e altezza usare
	control = GetDlgItem( IDC_SAMPLE_TEXT)->m_hWnd;
	font = (HFONT)::SendMessage( control, WM_GETFONT, 0, 0);
	::SendMessage( wnd, WM_SETFONT, (WPARAM)font, 0);

	m_layer.SetHeight( rccombo.Height());
	m_layer.Attach( wnd);

	// Imposto i valori possibili nella combo
	int idx = m_layer.AddString( "(indeterminato)");
	m_layer.SetItemData( idx, 0);
	for( a=0; a<16; a++)
	{
		idx = m_layer.AddString( ((CMainFrame*)AfxGetMainWnd())->m_layerNames[a]);
		m_layer.SetItemData( idx, a+1);
	}

	// Seleziono quello giusto
	if( !bCommonval)
		m_layer.SelectString( -1, "(indeterminato)");
	else
		m_layer.SelectString( -1, ((CMainFrame*)AfxGetMainWnd())->m_layerNames[nLayer]);


	// TODO: posizionamento dialog/pulsanti in fondo

	// Setta il focus al primo controllo
	CWnd *primo = GetDlgItem( 2000+1);
	if( primo != NULL)
		primo->SetFocus();

	return FALSE;
}


/*
	La conferma delle modifiche viene fatta impostando gli attributi per cui sono stati
	specificati dei valori (le editbox vuote e le combobox settate su "(indeterminato)" indicano
	attributi che non vogliamo modificare e quindi vanno lasciate stare). Da notare che in questa
	versione spetta alla classe verificare se il nuovo valore dell'attributo va bene; questa
	dialog non riporta alcun tipo di errore.
*/

void CGiveStringDialog::OnOK()
{
	UINT idx=2000;
	CString name, value, values;

	while( GetDlgItemText( idx, name))
	{
		if( lstrcmp( name, "Layer"))
		{
			GetDlgItemText( idx+1, value);
			if( value != "" && value != "(indeterminato)")
			{
				int a, n=m_SelArray->GetSize();
				for( a=0; a<n; a++)
					m_SelArray->GetAt(a)->SetAttrib( name, value);
			}
		}
		else
		{
			int nLayer = m_layer.GetCurSel();
			if( nLayer > 0)
			{
				int a, n=m_SelArray->GetSize();
				for( a=0; a<n; a++)
					m_SelArray->GetAt(a)->SetLayer( nLayer-1);
			}
		}

		idx += 2;
	}

	CDialog::OnOK();
}

BOOL CGiveStringDialog::DestroyWindow() 
{
	::DestroyWindow( m_layer.Detach());
	return CDialog::DestroyWindow();
}
