// LayerComboBox.cpp : implementation file
//

#include "stdafx.h"
#include "ElecDraw.h"
#include "LayerComboBox.h"
#include "Primitive.h"
#include "DlgMacroBar.h"
#include "ConfigDialog.h"
#include "GridDialog.h"
#include "ViewToolbar.h"
#include "ElecDrawDoc.h"
#include "ElecDrawView.h"
#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CLayerComboBox

CLayerComboBox::CLayerComboBox()
{
	m_height = 0;
}

CLayerComboBox::~CLayerComboBox()
{
}


BEGIN_MESSAGE_MAP(CLayerComboBox, CComboBox)
	//{{AFX_MSG_MAP(CLayerComboBox)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CLayerComboBox message handlers

void CLayerComboBox::DrawItem(LPDRAWITEMSTRUCT lpDrawItemStruct) 
{
	int idxLayer = lpDrawItemStruct->itemData;
	COLORREF layer = idxLayer==0 ? RGB(0,0,0) :
		((CMainFrame*)AfxGetMainWnd())->m_layerColors[idxLayer-1];
	COLORREF back = GetSysColor( COLOR_WINDOW);
	COLORREF backSel = GetSysColor( COLOR_HIGHLIGHT);
	COLORREF foreSel = GetSysColor( COLOR_HIGHLIGHTTEXT);

	COLORREF clrForeground = SetTextColor( lpDrawItemStruct->hDC, 
		lpDrawItemStruct->itemState & ODS_SELECTED ? foreSel : layer);

	COLORREF clrBackground = SetBkColor( lpDrawItemStruct->hDC, 
		lpDrawItemStruct->itemState & ODS_SELECTED ? 
		backSel : back);

	// Calculate the vertical and horizontal position. 
	TEXTMETRIC tm;
	int x, y;
	GetTextMetrics( lpDrawItemStruct->hDC, &tm); 
	y = (lpDrawItemStruct->rcItem.bottom + lpDrawItemStruct->rcItem.top - 
		tm.tmHeight) / 2; 
	x = LOWORD( GetDialogBaseUnits()) / 4; 

	// Get and display the text for the list item. 
	char achTemp[256];
	::SendMessage( lpDrawItemStruct->hwndItem, CB_GETLBTEXT, 
		lpDrawItemStruct->itemID, (LPARAM) (LPCSTR) achTemp); 

	ExtTextOut( lpDrawItemStruct->hDC, tm.tmHeight*3/2 + 2 * x, y, 
		ETO_CLIPPED | ETO_OPAQUE, &lpDrawItemStruct->rcItem, 
		achTemp, lstrlen(achTemp), NULL); 

	if( idxLayer != 0)
	{
		HBRUSH oldbrush, brush = ::CreateSolidBrush( layer);
		oldbrush = (HBRUSH)::SelectObject( lpDrawItemStruct->hDC, brush);
		Rectangle( lpDrawItemStruct->hDC, 2*x, y, 2*x+tm.tmHeight, y+tm.tmHeight);
		::SelectObject( lpDrawItemStruct->hDC, oldbrush);
		::DeleteObject( brush);
	}

	// Restore the previous colors.
	SetTextColor( lpDrawItemStruct->hDC, clrForeground); 
	SetBkColor( lpDrawItemStruct->hDC, clrBackground);  
}

void CLayerComboBox::MeasureItem(LPMEASUREITEMSTRUCT lpMeasureItemStruct) 
{
	lpMeasureItemStruct->itemHeight = m_height;
}
