// MainFrm.h : interface of the CMainFrame class
//
/////////////////////////////////////////////////////////////////////////////

class CMainFrame : public CMDIFrameWnd
{
public:
	CMainFrame();
	DECLARE_DYNCREATE(CMainFrame)

	void LoadMacros();
	void SaveWindowPos();
	void SaveConfigOptions();
	void LoadConfigOptions();
	void ExitProcedure();

	void LayerDefaultNames();
	void LayerDefaultColors();
	void LayerDefaultShow();
	void LayerDefaultPrint();
	void LayerLoadSettings();
	void LayerSaveNames();
	void LayerSaveColors();
	void LayerSaveShow();
	void LayerSavePrint();

	void LoadLibNames();
	void SaveLibNames();


	int GetCurrentLayer() { return m_currentLayer; };

	SELECTED_PRIMITIVE				m_SelectedPrimitive;
	SELECTED_PRIMITIVE				m_OldPrimitive;
	CStatusBar						m_wndStatusBar;
	CToolBar						m_wndToolBar;
	CToolBar						m_wndPrimitiveBar;
	CDlgMacroBar					m_wndDlgMacroBar;
	CConfigDialog					m_dlgConfig;
	CLayerComboBox					m_comboLayer;
	CFont							m_FontLittle;

	BOOL							m_bNoWarning;
	BOOL							m_bRegionDebug;
	
	int								m_nUnnamedLib;

	// Layer stuffs
	COLORREF			m_layerColors[16];
	CString				m_layerNames[16];
	BOOL				m_bLayerShow[16];
	BOOL				m_bLayerPrint[16];

	// Lame bastard trick
	CObList				m_DocCache;

protected:
	int					m_currentLayer;

	CWinThread*						m_CacheUpdateThread;
	BOOL							m_bDestroyCacheThread;
	static UINT CacheUpdateThread( LPVOID pParam );
	void DestroyAndReload();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMainFrame)
	public:
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual void RecalcLayout(BOOL bNotify = TRUE);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CMainFrame();


#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

// Generated message map functions
protected:
	//{{AFX_MSG(CMainFrame)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnViewPrimitiveBar();
	afx_msg void OnUpdateViewPrimitiveBar(CCmdUI* pCmdUI);
	afx_msg void OnButtonSelect();
	afx_msg void OnButtonLine();
	afx_msg void OnButtonBezier();
	afx_msg void OnButtonPoly();
	afx_msg void OnClose();
	afx_msg void OnEndSession(BOOL bEnding);
	afx_msg void OnButtonConn();
	afx_msg void OnViewRefreshMacro();
	afx_msg void OnButtonMacro();
	afx_msg void OnUpdateButtonMacro(CCmdUI* pCmdUI);
	afx_msg void OnOptionsConfig();
	afx_msg void OnViewMacroBar();
	afx_msg void OnUpdateViewMacroBar(CCmdUI* pCmdUI);
	afx_msg void OnButtonZoom();
	afx_msg void OnButtonEllipse();
	afx_msg void OnButtonRectangle();
	afx_msg void OnEditPastenew();
	afx_msg void OnUpdateEditPastenew(CCmdUI* pCmdUI);
	afx_msg void OnButtonDrag();
	afx_msg void OnButtonExtendedtext();
	afx_msg void OnViewLayers();
	afx_msg void OnButtonPad();
	afx_msg void OnButtonVia();
	afx_msg void OnLayerChange();
	//}}AFX_MSG
	afx_msg void OnMacroSelChange( NMHDR * pNotifyStruct, LRESULT * result );

	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

