// stdafx.h : include file for standard system include files,
//  or project specific include files that are used frequently, but
//      are changed infrequently
//

#define VC_EXTRALEAN		// Exclude rarely-used stuff from Windows headers

#include <afxwin.h>         // MFC core and standard components
#include <afxext.h>         // MFC extensions
#include <afxmt.h>			// Mutithread
#include <afxsock.h>		// Socket
#include <afxtempl.h>
#ifndef _AFX_NO_AFXCMN_SUPPORT
#include <afxcmn.h>			// MFC support for Windows 95 Common Controls
#endif // _AFX_NO_AFXCMN_SUPPORT

#include <mmsystem.h>

#include "resource.h"       // main symbols

// Globalz
extern CString _BaseDir;
extern CMapStringToOb _MacroCache;
extern CMapStringToString _FileNamesCache;

// Versione del programma (sempre 0 per la versione debug)
#ifdef _DEBUG
#define PROGRAM_VERSION			0
#define VERSION_STRING			"DEBUG"
#else
#define PROGRAM_VERSION			964
#define VERSION_STRING			"Beta"
#endif

// Costanti
#define	DEFAULT_AREAX			2500
#define DEFAULT_AREAY			2500
#define DEFAULT_MICRON_PER_LU	127			// Centesimi di millimetro per unita` logica
#define XMACRO_ORIG				100
#define YMACRO_ORIG				100
#define MACROS_DIR				"macros"
#define MACROS_EXT				"fcm"
#define LIBS_DIR				"libs"
#define LIBS_EXT				"fcl"
#define DOCS_HEADER				"FIDOCAD"
#define MACROS_HEADER			"MACROCAD"
#define LIBS_HEADER				"FIDOLIB"
#define DEFAULT_SNAP			5
#define DEFAULT_GRID			5
#define DEFAULT_DOCZOOM			4.0
#define DEFAULT_MACROZOOM		8.0
#define MAX_SNAP				20
#define MAX_GRID				40
#define NUM_PRIMITIVES			13				// Vedi enum qui sotto
#define MAX_DEFINING_POINTS		10
#define SELECTOR_SIZE			10				// Dimensione del selettore dei punti di definizione
#define TEXT_HEIGHT				5
#define MIN_ZOOM				10
#define MAX_ZOOM				2000
#define MAGSTEP					1.3				// Incremento/decremento di zoom usando la lente di ingrandimento
#define BORDER_PROXIMITY		30				// Distanza dai bordi della finestra che genera lo scrolling automatico
#define UNDO_BUFFER_SIZE		262144			// default 256KB di undo buffer per ogni documento

// Bitmask dei bordi
#define BORD_LEFT				0x00000001
#define BORD_TOP				0x00000002
#define BORD_RIGHT				0x00000004
#define BORD_BOTTOM				0x00000008

// Bitmask delle proprieta'
#define PROP_ROTATEFULL			0x00000001	// Puo' ruotare completamente
#define PROP_ROTATEHALF			0x00000002	// I suoi punti di def. possono ruotare
#define PROP_NEEDPROPS			0x00000004	// E` necessario aprire la dialog delle proprieta` alla creazione dell'oggetto
#define PROP_UPDATEONZOOM		0x00000008	// Richiede che la sua regione sia aggiornata dopo un cambiamento di scala
#define PROP_ISMACRO			0x00000010	// E' una macro (o sua classe derivata)
#define PROP_SWAPFULL			0x00000020	// Puo' swappare completamente
#define PROP_SWAPHALF			0x00000040	// I suoi punti di def. possono swappare
#define PROP_SERIALCREATE		0x00000080	// Crea tante primitive in serie
#define PROP_ERASEONSELECT		0x00000100	// E` necessario cancellare il comp. quando si seleziona (non basta disegnarci sopra)

// Useful macroz
#define ABS(X)				(((X)>0)?(X):(-(X)))
#define MINIMO(X,Y)			((X)>(Y)?(Y):(X))
#define MASSIMO(X,Y)		((X)>(Y)?(X):(Y))

typedef enum {	B_NONE, B_ZOOM, B_DRAG, B_LINE, B_EXTENDEDTEXT, B_CONNECTION, B_BEZIER,
				B_POLY, B_ELLIPSE, B_RECTANGLE, B_MACRO, B_VIA, B_PAD } SELECTED_PRIMITIVE;

typedef enum { DOC_NONE, DOC_NORMAL, DOC_MACRO, DOC_LIBRARY } DOC_TYPE;

typedef enum { NEAR_NONE=-2, NEAR_BODY=-1, NEAR_SELECTOR_0=0 } PROXIMITY_TYPE;
