#include "stdafx.h"
//#include "DlgSplash.h"
#include "ElecDraw.h"
#include "DlgMacroBar.h"
#include "Primitive.h"
#include "GridDialog.h"
#include "ConfigDialog.h"
#include "ViewToolBar.h"
#include "ElecDrawDoc.h"
#include "ElecDrawLibDoc.h"
#include "ElecDrawView.h"
#include "LayerComboBox.h"
#include "MainFrm.h"

#include <stdlib.h>

BEGIN_MESSAGE_MAP(CViewToolBar, CToolBar)
	ON_WM_CREATE()
	ON_WM_SIZE()
	ON_EN_CHANGE(IDC_EDIT_TL, OnTitleChange)
END_MESSAGE_MAP()

CViewToolBar::CViewToolBar()
{
	m_FixedSize = 0;
	m_bLib = FALSE;
	m_Doc = NULL;
}

CViewToolBar::~CViewToolBar()
{
}

CViewToolBar::OnCreate( LPCREATESTRUCT lpcs)
{
	if( CToolBar::OnCreate( lpcs) == -1)
		return -1;

	// Carica la toolbar
	if( !LoadToolBar( IDR_NAMETOOLBAR))
		return -1;

	BOOL bModified = m_Doc->IsModified();

	// Misura la larghezza del pulsante (sara' un riferimento)
	CRect rcb;
	GetItemRect( 0, &rcb);

	// Trova le misure del font di sistema e vede se lo puo' sfruttare
	CFont sysfont;
	sysfont.Attach( ::GetStockObject( SYSTEM_FONT));
	LOGFONT lf;
	sysfont.GetLogFont( &lf);
	if( lf.lfHeight < 0)
		lf.lfHeight *= -1;

	// Font per le combo
	m_FontLittle.CreateFont( MINIMO(lf.lfHeight,rcb.Height()-8), 0, 0, 0, FW_THIN, FALSE, FALSE, 0,
		DEFAULT_CHARSET, OUT_TT_PRECIS, CLIP_TT_ALWAYS, DEFAULT_QUALITY, DEFAULT_PITCH |
		TMPF_TRUETYPE, "Arial");

	// Font per le static
	m_FontBig.CreateFont( MINIMO(lf.lfHeight,rcb.Height()-6), 0, 0, 0, FW_THIN, FALSE, FALSE, 0,
		DEFAULT_CHARSET, OUT_TT_PRECIS, CLIP_TT_ALWAYS, DEFAULT_QUALITY, DEFAULT_PITCH |
		TMPF_TRUETYPE, "Arial");


	// Verifica di che tipo e' questo documento
	CElecDrawView* view = (CElecDrawView *)(((CMDIChildWnd *)GetParent())->GetActiveView());
	CElecDrawDoc* doc = view->GetDocument();
	if( doc->GetID() == IDR_CHILDFRAMELIB)
		m_bLib = TRUE;
	else
		m_bLib = FALSE;

	CClientDC dc( this);
	CFont *oldfont;
	oldfont = dc.SelectObject( &m_FontBig);

	// Calcola le dimensioni delle static
	CString str1 = "Zoom";
	CSize size1 = dc.GetTextExtent( str1);
	CString str2 = "TL";
	CSize size2 = dc.GetTextExtent( str2);
	CString str3 = "TBM";
	CSize size3 = dc.GetTextExtent( str3);
	CString str4 = "TLM";
	CSize size4 = dc.GetTextExtent( str4);

	// Dimensiona subito i controlli con larghezza fissa
	SetButtonInfo( 1, (UINT)IDC_STATIC, TBBS_SEPARATOR, size1.cx+10);
	SetButtonInfo( 2, (UINT)IDC_COMBO_ZOOM, TBBS_SEPARATOR, rcb.Width()*3);
	SetButtonInfo( 3, (UINT)IDC_STATIC, TBBS_SEPARATOR, size2.cx+10);
	m_FixedSize = size1.cx + size2.cx + 20 + rcb.Width()*3;
	if( m_bLib)
	{
		SetButtonInfo( 5, (UINT)IDC_STATIC, TBBS_SEPARATOR, size3.cx+10);
		SetButtonInfo( 7, (UINT)IDC_STATIC, TBBS_SEPARATOR, size4.cx+10);
		m_FixedSize += size3.cx + size4.cx + 20;
	}

	// Procede alla creazione dei controlli!!!

	// Static 1 (Zoom)
	CRect r;
	GetItemRect( 1, &r);
	m_Static1.Create( str1, WS_CHILD | WS_VISIBLE | SS_CENTER, r, this, (UINT)IDC_STATIC);
	m_Static1.SetFont( &m_FontBig);

	// Combo 1 (Zoom)
	GetItemRect( 2, &r);
	r.bottom = r.top+r.Height()*5;
	m_ComboZoom.Create( WS_CHILD | WS_VISIBLE | WS_BORDER | CBS_DROPDOWN | 
		CBS_AUTOHSCROLL | WS_VSCROLL | WS_TABSTOP, r, this, IDC_COMBO_ZOOM);
	m_ComboZoom.SetFont( &m_FontLittle);
	m_ComboZoom.AddString( "50%");
	m_ComboZoom.AddString( "75%");
	m_ComboZoom.AddString( "100%");
	m_ComboZoom.AddString( "150%");
	m_ComboZoom.AddString( "200%");
	m_ComboZoom.AddString( "300%");
	m_ComboZoom.AddString( "400%");
	m_ComboZoom.AddString( "600%");
	m_ComboZoom.AddString( "800%");
	m_ComboZoom.AddString( "1000%");
	m_ComboZoom.SetWindowText("50%");

	// Static 2 (TL)
	GetItemRect( 3, &r);
	m_Static2.Create( str2, WS_CHILD | WS_VISIBLE | SS_CENTER, r, this, (UINT)IDC_STATIC);
	m_Static2.SetFont( &m_FontBig);

	// Edit 1 (TL)
	GetItemRect( 4, &r);
	m_EditTL.Create( WS_CHILD | WS_VISIBLE | ES_AUTOHSCROLL |  WS_TABSTOP,
		r, this, IDC_EDIT_TL);
	::SetWindowLong( m_EditTL.m_hWnd, GWL_EXSTYLE, WS_EX_CLIENTEDGE);
	m_EditTL.SetFont( &m_FontBig);
	m_EditTL.SetWindowText( _TitleLong);

	if( m_bLib)
	{
		// Static 3 (TBM)
		GetItemRect( 5, &r);
		m_Static3.Create( str3, WS_CHILD | WS_VISIBLE | SS_CENTER, r, this, (UINT)IDC_STATIC);
		m_Static3.SetFont( &m_FontBig);

		// Edit 2 (TBM)
		GetItemRect( 6, &r);
		m_EditTBM.Create( WS_CHILD | WS_VISIBLE | ES_AUTOHSCROLL | WS_TABSTOP,
			r, this, IDC_EDIT_TBM);
		::SetWindowLong( m_EditTBM.m_hWnd, GWL_EXSTYLE, WS_EX_CLIENTEDGE);
		m_EditTBM.SetFont( &m_FontBig);

		// Static 4 (TLM)
		GetItemRect( 7, &r);
		m_Static4.Create( str4, WS_CHILD | WS_VISIBLE | SS_CENTER, r, this, (UINT)IDC_STATIC);
		m_Static4.SetFont( &m_FontBig);

		// Combo 2 (TLM)
		GetItemRect( 8, &r);
		r.bottom = r.top+r.Height()*15;
		m_ComboTLM.Create( WS_CHILD | WS_VISIBLE | WS_BORDER | CBS_DROPDOWN |
			WS_VSCROLL | CBS_AUTOHSCROLL | WS_TABSTOP, r, this, IDC_COMBO_TLM);
		m_ComboTLM.SetFont( &m_FontLittle);
		
		// Imposta le voci della combo
		if( m_Doc != NULL)
		{
			STRARRAY* libArray = &(((CElecDrawLibDoc*)m_Doc)->m_libArray);
			int a, n=libArray->GetSize();
			CString Short, Long;
			for( a=0; a<n; a++)
			{
				if( CMacro::ScanLibraryMacro( *(libArray->GetAt(a)),
					NULL, a==0? &Short : NULL, &Long, NULL))
						m_ComboTLM.AddString( Long);
			}

			m_EditTBM.SetWindowText( Short);
			m_ComboTLM.SetCurSel(0);
		}
	}

	dc.SelectObject( oldfont);

	m_Doc->SetModifiedFlag( bModified);
	return 0;
}

void CViewToolBar::OnSize(UINT nType, int cx, int cy) 
{
	CToolBar::OnSize(nType, cx, cy);
	
	// Ridimensiona i controlli
	if( !m_bLib && m_EditTL.m_hWnd != NULL  ||
		m_bLib && m_EditTL.m_hWnd != NULL && m_EditTBM.m_hWnd != NULL &&
		m_ComboTLM.m_hWnd != NULL)
	{
		// Lo spazio disponibile e' diviso in 2 modi:
		// 1) FCD, FCM: 100% a m_EditTL;
		// 2) FCL: 40% a m_EditTL, 20% a m_EditTBM, 40% a m_ComboTLM

		CRect r1, r2, r3;
		m_EditTL.GetWindowRect( &r1);
		ScreenToClient( &r1);
		if( m_bLib)
		{
			m_EditTBM.GetWindowRect( &r2);
			ScreenToClient( &r2);
			m_ComboTLM.GetWindowRect( &r3);
			ScreenToClient( &r3);
		}
		
		// cx e' merda, quindi trovo la dimensione direttamente
		CRect r;
		GetClientRect( &r);
		int avail = r.Width() - 30 - m_FixedSize;
		if( avail > 40)
		{
			if( m_bLib)
			{
				SetButtonInfo( 4, (UINT)IDC_EDIT_TL, TBBS_SEPARATOR, (int)(avail*0.4));
				SetButtonInfo( 6, (UINT)IDC_EDIT_TBM, TBBS_SEPARATOR, (int)(avail*0.2));
				SetButtonInfo( 8, (UINT)IDC_COMBO_TLM, TBBS_SEPARATOR, (int)(avail*0.4));
				
				m_EditTL.SetWindowPos( NULL, 0, 0, (int)(avail*0.4), r1.Height(), SWP_NOMOVE | SWP_NOZORDER);
				GetItemRect( 5, &r);
				m_Static3.SetWindowPos( NULL, r.left, r.top, 0, 0, SWP_NOSIZE | SWP_NOZORDER);
				GetItemRect( 6, &r);
				m_EditTBM.SetWindowPos( NULL, r.left, r.top, (int)(avail*0.2), r2.Height(), SWP_NOZORDER);
				GetItemRect( 7, &r);
				m_Static4.SetWindowPos( NULL, r.left, r.top, 0, 0, SWP_NOSIZE | SWP_NOZORDER);
				GetItemRect( 8, &r);
				m_ComboTLM.SetWindowPos( NULL, r.left, r.top, (int)(avail*0.4), r2.Height(), SWP_NOZORDER);
			}
			else
			{
				SetButtonInfo( 4, (UINT)IDC_EDIT_TL, TBBS_SEPARATOR, avail);
				m_EditTL.SetWindowPos( NULL, 0, 0, avail,
					r1.Height(), SWP_NOMOVE | SWP_NOZORDER);
			}
		}
	}
}

void CViewToolBar::ArcordetDocument( CElecDrawDoc* doc)
{
	m_Doc = doc;
}

void CViewToolBar::OnTitleChange()
{
	m_Doc->SetModifiedFlag();
}

void CViewToolBar::SetInitialTitles( CString& title)
{
	_TitleLong = title;
}

